unit Unit1;

{
  Program to poll the serial logger and log the results to a text file.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, CommDrv, StdCtrls,
  Registry, Mask;

type
  TForm1 = class(TForm)
    Label2: TLabel;
    CommPortDriver1: TCommPortDriver;
    Timer1: TTimer;
    Memo1: TMemo;
    Label5: TLabel;
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Label3: TLabel;
    Label4: TLabel;

    procedure CommPortDriver1ReceiveData(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  buffer:string;
  wantedLineCount : Integer;
  IniFile : TRegIniFile;




implementation

{$R *.DFM}

procedure TForm1.CommPortDriver1ReceiveData(Sender: TObject;
  DataPtr: Pointer; DataSize: Integer);

var
  comRxDataA: array[0..300] of Char;
  finished : boolean ;
  foundCRLFpos :integer;
  line , rest : string;
begin
    {
      Copy received chars to A.
      Look for lines and
    }

    StrLCopy(comRxDataA, DataPtr, DataSize);

    // label2.caption :=  IntToStr( DataSize );
    // label3.caption :=  IntToStr( ord(CommPortDriver1.ComPort ) );

    buffer := buffer + comRxDataA;

    finished := false ;

    // Memo1.Lines.Add( ':' + buffer + ':'  );
    {
      wait for a line ending with *;
      send d; command
      wait for number of lines required.
      save file;
      close down
    }

    while ( not finished ) do
    begin
      foundCRLFpos := pos( '*' , buffer );
      if ( foundCRLFpos > 0 ) then
      begin
        { split buffer }

        line := copy( buffer , 1,foundCRLFpos );
        // label6.caption :=  line;
        delete( buffer , 1,foundCRLFpos );
        Memo1.Lines.Add( trim( line ) );
        wantedLineCount := wantedLineCount+1;

        label4.caption := 'line: ' + IntToStr( wantedLineCount ) +
         ' : ' + trim ( line ) ;

        if ( wantedLineCount  = 3 ) then
        begin
          CommPortDriver1.SendString('d;');
          label2.caption := 'Waiting d; Output ...' ;
        end;
  
        if ( wantedLineCount  = 17 ) then
          label2.caption := 'waiting for s; output' ;
          
        if ( wantedLineCount  = 18 ) then
        begin
          CommPortDriver1.SendString('g0708;');
          label2.caption := 'Resetting data Pointer ...' ;
        end;

        if ( wantedLineCount  = 20 ) then
        begin
          CommPortDriver1.SendString('p0708;');
          label2.caption := 'Resetting data Pointer ...' ;
        end;


        if ( wantedLineCount  = 24 ) then
        begin
          CommPortDriver1.disconnect ;
          //Memo1.Lines.Add( '============================' );
          //Memo1.Lines.Add( '  all wanted lines gathered ' );
          Memo1.Lines.Add( '============================' );
          Memo1.Lines.SaveToFile( 'log.txt' );
          label2.caption := 'disconnected' ;
          { autoclose as all done }
          Form1.close;
        end
      end
      else
        finished := true;
    end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  
  Button1Click(Sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  temp : string;
  opStr: string;
  comCounter : integer;
  newPortNum : integer;

begin
{ create }
  IniFile  := TRegIniFile.Create('comtestDHR.ini');
  Edit1.Text := IniFile.ReadString('ComPort','lastComPort','1');

  Memo1.clear;
  { try and connect to each port in turn }
  opStr := 'ports: ';
  CommPortDriver1.ComPort := pnCOM1;

  for comCounter := 0 to 20 do
  begin
   // Form1.CommPortDriver1.ComPort:= TComPortNumber( StrToInt( Form1.Edit1.Text ) - 1 ) ;
   // Form1.CommPortDriver1.Connect;

    if CommPortDriver1.connected then
      CommPortDriver1.disconnect;

    CommPortDriver1.ComPort :=  TComPortNumber( comCounter );
    if CommPortDriver1.connected then
      CommPortDriver1.disconnect;

    if not CommPortDriver1.connected then
      CommPortDriver1.connect;

    if CommPortDriver1.connected then
        CommPortDriver1.SendString( 's;' );

    if CommPortDriver1.connected then
      opStr := opStr + IntToStr( comCounter + 1 ) + ','
    else
      opStr := opStr + '_,';

  end;
  Label3.caption := opStr;

  if not CommPortDriver1.connected then
    CommPortDriver1.disconnect;


  // validate port number
  newPortNum := StrToIntDef( Edit1.Text, -1 ) ;
  if ( newPortNum < 1 ) OR (newPortNum > 256) then
  begin
     // force port number to valid range
     Edit1.Text := '1';
     newPortNum := 1  ;
  end;

  IniFile.WriteString('ComPort','lastComPort',IntToStr(newPortNum) );
  CommPortDriver1.ComPort := TComPortNumber( newPortNum - 1 );

  // CommPortDriver1.ComPort := pnCOM1;

  if not CommPortDriver1.connected then
    CommPortDriver1.connect;

  if CommPortDriver1.connected then
  begin
    label2.caption := 'connected' ;
    buffer := '';
    // Memo1.clear;
    if FileExists( 'log.txt' ) then
      Memo1.Lines.LoadFromFile('log.txt')
    else
      Memo1.clear;

    Memo1.Lines.Add( '============================' );
    Memo1.Lines.Add( 'Polled At:'+ FormatDateTime(' dd/mm/yyyy hh:mm ', Now) );
    Memo1.Lines.Add( '============================' );
    wantedLineCount := 0;
    label2.caption := 'Waiting for logger...' ;
    temp := '#$d ;' ;
    CommPortDriver1.SendString( temp );
  end
  else
  begin
    label2.caption := 'failed to connect' ;
  end;

end;

procedure TForm1.Edit1Change(Sender: TObject);
var
  newPortNum : Integer;
begin
  // must be blank or 1..256
  if( Edit1.Text <> '' ) then
  begin
    newPortNum := StrToIntDef( Edit1.Text, -1 ) ;
    if ( newPortNum < 1 ) OR (newPortNum > 256) then
      Edit1.Text := '1';
  end;
  IniFile.WriteString('ComPort','lastComPort',Edit1.Text );
  IniFile.WriteString('ComPort','','doug' );

end;

end.
