{
    This unit contains the Delphi based Pic Programmer array.

}

unit pic_prog_delph;

interface

const
     maxPicData = $2000+$1400;
type

   HexDataT  = record
       ip     :string;
       error  : integer;
       address: integer;
       count  : integer;
       recType: integer;
       finished : boolean;
       maxProgAddress: integer;
       maxDataAddress: integer;
       maxFuseAddress: integer;

       data   : array[0..MaxPicData] of integer;

   end;

   var
     { outputs }
     PP_DATA,
     PP_CLOCK,
     PP_DATA_RD,
     PP_NVPP,
     PP_MONO,
     PP_N5Volt,
     {}
     { inputs }
     PP_BSY,
     PP_RD_DATA,
     DELAY_SHORT,
     DELAY_LONG,
     DELAY_PAUSE : Integer;
     crownhill,mec :integer;
     {}

{
; The Crownhill is a serial port programmer.
; TXD -> VPP and +5, To apply, Set the BREAK to apply continously
; DTR -> Data to
; RTS -> Clock
; CTS <- Data from PIC
;
;
}


Procedure ProcessLine( var HexData:HexDataT; ipStr:string );
{Procedure ProcessLine( var HexData:HexDataT; ipStr:string );}

{
  Procedure ProcessFile( filename: string );
  procedure Apply5VandVPP;
  procedure Remove5VandVPP;
  procedure Apply5V;
  procedure wrtData(cmd:integer);
  function  rdData:integer;
}

implementation



{
; The Crownhill is a serial port programmer.
; TXD -> VPP and +5, To apply, Set the BREAK to apply continously
; DTR -> Data to
; RTS -> Clock
; CTS <- Data from PIC
;
;
}

Procedure ProcessLine( var HexData:HexDataT; ipStr:string );
var
   cntStr,addrStr,rectypeStr,dataStr:string;
   cnt, current, LoByte, HiByte :integer;
begin
    HexData.error := -1;
    if ':' =copy(ipstr,1,1) then
    begin
      cntStr     := copy( ipstr,2,2);
      addrStr    := copy( ipstr,4,4);
      rectypeStr := copy( ipstr,8,2);
      dataStr    := copy( ipstr,10,length(ipStr));
      if rectypeStr = '01' then hexData.finished := true;
      if rectypeStr = '00' then
      begin
        Val('$'+cntStr, hexData.count,  HexData.error);
        Val('$'+addrStr,hexData.address,HexData.error);
        hexData.count := hexData.count div 2;
        hexData.address := hexData.address div 2;
        current := hexData.address ;
        for cnt := 0 to HexData.count-1 do
        begin
          val('$'+copy(dataStr,cnt*4+1,2), loByte, HexData.error );
          val('$'+copy(dataStr,cnt*4+3,2), hiByte, HexData.error ) ;
          hexData.Data[ current ] := hiByte*256 + loByte ;
          current := current + 1;
        end;
        if ( current < $2000 ) then
          hexData.maxProgAddress := current;
      end;
    end;

end;


{$IFDEF buildOldCode }

{Program PICPROG;
{uses DOS,CRT;
{ A combined MEC and Crownhill pic programmer }
{ Mec Systems PIC programmer

;
;	Printer Port	Function	16C84		74LS244			PROG_DEV
; =========================================================================================
;	PP_DB0		Data	>			> Tri state >		RB7
;	PP_DB1		CLOCK	>			> Buffer >		RB6
;	PP_DB2		Data /WR|RD			enable
;	PP_DB3		/VPP|GND	RB6
;	PP_DB4		Monostable >	RB5
;	PP_DB5		/+5Volt|GND	RB7
;	PP_DB6		NC
;	PP_DB7		NC
;	PP_BSY		Monstable <	RB4
;	PP_PAPER	Buffered Data			< buffer <		RB7
;			/VPP		RB0	via Common Emiter Transistor	VPP & MCLR
;			/VDD		RB1	via Common Emiter Transistor	VDD & +5 Volts
;
;			LED_GREEN	RA0	bi Colour 2 wire LED
;			LED_RED		RA1	bi Colour 2 wire LED
;			NC		RA2
;			NC		RA3
;			NC		RA4
;
;
; Timer - 11 ms timer
; PP_DB4 -> ____-----___-------------------__
; BSY	 <- _______________________-----
;			|<-t=11ms->|
;
}


procedure delay( del : integer );
begin
end;


procedure select_programmer( prog : integer );
BEGIN
  if prog = 0 then { Crownhill Serial Port Bits }
  BEGIN

     crownhill := 1;
     {output}
     PP_DATA    :=  1;
     PP_CLOCK   :=  2;
     PP_DATA_RD :=  0; { this has no equivalent on the serial }
     PP_NVPP    :=$4000;
     PP_MONO    :=$0;
     PP_N5Volt  :=$4000;

     { inputs }
     PP_BSY     :=$00;{ this has no equivalent on the serial }
     PP_RD_DATA :=$10;
     { }
     DELAY_SHORT := 10;
     DELAY_LONG  := 300;
     DELAY_PAUSE := 1000;
   end;
   if prog = 1 then { MEC }
   BEGIN
    { MEC Printer port Bits }
     mec := 0;
     {output
     PP_DATA    :=  1;
     PP_CLOCK   :=  2;
     PP_DATA_RD :=  4;
     PP_NVPP    :=  8;
     PP_MONO    :=$10;
     PP_N5Volt  :=$20;
     {}
     { inputs
     PP_BSY     :=$80;
     PP_RD_DATA :=$20;
     {}
     DELAY_SHORT := 10;
     DELAY_LONG  := 300;
     DELAY_PAUSE := 1000;

   END;
END;
{
; The Crownhill is a serial port programmer.
; TXD -> VPP and +5, To apply, Set the BREAK to apply continously
; DTR -> Data to
; RTS -> Clock
; CTS <- Data from PIC
;
;
}

const
     LD_CONF     = $00;
     LD_PRG_MEM  = $02;
     RD_PRG_MEM  = $04;
     INC_ADDR    = $06;
     PROG        = $08;
     LD_DATA_MEM = $03;
     RD_DATA_MEM = $05;
     ERASE_PROG  = $09;
     ERASE_DATA  = $0B;
     DIS_PROTECT1= $01;
     DIS_PROTECT2= $07;


const
  BreakFlag : Boolean = FALSE;
{  PRT_PORT  =$378; {}
  PRT_PORT  =$3BC; {}

const
  COM=$2F0; { would be better if $3F0 }
  COM1_PORT = $3F8;
  COM_PORT  = COM1_PORT;

  hex:string = '0123456789ABCDEF';

const
   DSunknown = 0;
   DSprog    = 1;
   DSid      = 2;
   DSconf    = 3;
   DSeeprom  = 4;
   DSother   = 5;
var
  prt_image : integer;
  temp      : integer;
  ipFile    : TEXT;
  DSstate   : integer;
  fileName  : string;
  error_flag: boolean;

procedure disable;
BEGIN
{  inline ( <$FA ) }{ CTI }
END;

procedure enable;
BEGIN
{  inline ( <$FB )}{ sti }
END;


function tohex( n :byte):string;
VAR
  ts:string[4];
BEGIN
  ts := '';
{
  ts[4] := hex[ ( n div 32 ) and $F + 1 ];
  ts[3] := hex[ ( n div 256 ) and $F + 1 ];
}

  ts := ts + hex[ ( n div 16 ) and $F + 1 ];
  ts := ts + hex[ ( n and $F ) + 1 ];
  tohex := ts;

END;


procedure wrtPrtPort( i:integer );
begin
{
  if mec = 1 then
    port[PRT_PORT] :=i;
  if crownhill = 1 then
  begin
    port[COM_PORT+4] := lo( i );
    port[COM_PORT+3] := hi( i );
  end;
 }

{  write(tohex(i):3); }
end;

function rdPrtPort:integer;
begin
{
  if mec = 1 then
      rdPrtPort := port[PRT_PORT+1];
  if crownhill = 1 then
      rdPrtPort := port[COM_PORT+6];
}
end;


procedure BSF( var b:integer; bitmask:integer );
BEGIN
  { force bits to one }
  b := b or bitmask;
END;

procedure BCF( var b:integer; bitmask:integer );
BEGIN
  { force bits to zero }
  b := b and not bitmask;
END;


procedure delay11ms;
begin
  { Reset Monostable }
  BCF( prt_image, PP_MONO );
  wrtPrtPort(prt_image);

  while ( PP_BSY = ( rdPrtPort AND PP_BSY ) ) {or not keypressed} do ;

  { Start Monostable }
  BSF( prt_image, PP_MONO );
  wrtPrtPort(prt_image);
  while ( 0 = ( rdPrtPort AND PP_BSY )) {or not keypressed} do ;
end;

procedure delay11s;
var
  cnt : integer;
begin
  for cnt := 0 to 1000 do
     delay11ms;
  ;
end;

{
procedure delay( dly : integer );
var
  cnt : integer;
begin
  for cnt := 0 to dly div 10 do
  begin
    delay11ms;
  end;
end;
}

procedure Apply5VandVPP;
begin
  BCF(prt_image,PP_N5Volt );
  wrtPrtPort(prt_image);
  delay(DELAY_SHORT);
  BSF(prt_image,PP_NVPP or PP_N5Volt );
  wrtPrtPort(prt_image);
  delay(DELAY_PAUSE);
end;

procedure Apply5V;
begin
  BCF(prt_image,PP_NVPP  or PP_MONO or PP_DATA or PP_CLOCK or PP_DATA_RD);
  BSF(prt_image,PP_N5Volt );
  wrtPrtPort(prt_image);
  delay(4000);
end;

procedure Remove5VandVpp;
begin
  BCF(prt_image,PP_NVPP or PP_N5Volt or PP_MONO
             or PP_DATA or PP_CLOCK  or PP_DATA_RD);
  wrtPrtPort(prt_image);
  delay(DELAY_LONG);
end;


procedure wrtCMD(cmd:integer);
var
  cnt : byte;
begin
{
  writeln;
  write('wrtCMD',tohex(cmd):4);
}
  {
     PP_DATA    =  1;
     PP_CLOCK   =  2;
     PP_DATA_RD =  4;
  }
  { zero bits }
  BCF(prt_image,PP_DATA or PP_CLOCK or PP_DATA_RD );
  wrtPrtPort(prt_image);
  for cnt := 0 to 5 do
  BEGIN
{
    writeln;
    write('bit:');
}
    if 0 = ( cmd and 1 )
    then
    begin
      BCF(prt_image, PP_DATA );
      wrtPrtPort(prt_image);
    end
    else
    begin
      BSF(prt_image, PP_DATA );
      wrtPrtPort(prt_image);
    end;
    BSF(prt_image, PP_CLOCK );
    wrtPrtPort(prt_image);
    BCF(prt_image, PP_CLOCK );
    wrtPrtPort(prt_image);
    cmd := cmd shr 1 ;
  END;
  { Turn data line into input, just incase command is read }
  BSF(prt_image,PP_DATA_RD );
  wrtPrtPort(prt_image);
end;

procedure wrtData(cmd:integer);
var
  cnt : byte;
begin
{
  writeln;
  write('wrtData',tohex(cmd):4);
}
  {
     PP_DATA    =  1;
     PP_CLOCK   =  2;
     PP_DATA_RD =  4;
  }
  { zero bits }
  cmd := cmd shl 1;
  BCF(prt_image,PP_DATA or PP_CLOCK or PP_DATA_RD );
  wrtPrtPort(prt_image);
  for cnt := 0 to 15 do
  BEGIN
{
    writeln;
    write('bit:');
}
    if 0 = ( cmd and 1 )
    then
    begin
      BCF(prt_image, PP_DATA );
      wrtPrtPort(prt_image);
    end
    else
    begin
      BSF(prt_image, PP_DATA );
      wrtPrtPort(prt_image);
    end;
    BSF(prt_image, PP_CLOCK );
    wrtPrtPort(prt_image);
    BCF(prt_image, PP_CLOCK );
    wrtPrtPort(prt_image);
    cmd := cmd shr 1 ;
  END;
end;

function rdData:integer;
var
  cnt : byte;
  cmd : integer;
begin

{
  writeln('rdData');
}
  {
     PP_DATA    =  1;
     PP_CLOCK   =  2;
     PP_DATA_RD =  4;
  }
{  delay(DELAY_LONG);}
  { zero bits }
  cmd := 0;
  BCF(prt_image,PP_DATA or PP_CLOCK );
  { Turn data line into input }
  BSF(prt_image,PP_DATA_RD );
  wrtPrtPort(prt_image);
  { do one bit and ignore }
  BSF(prt_image, PP_CLOCK );
  wrtPrtPort(prt_image);
  BCF(prt_image, PP_CLOCK );
  wrtPrtPort(prt_image);

  for cnt := 0 to 14 do
  BEGIN
{
    writeln;
    write('bit<');
}
    BSF(prt_image, PP_CLOCK  or PP_DATA ); { set the PP_DATA to bias CTS }
    wrtPrtPort(prt_image);
    { data is being presented }
    BCF(prt_image, PP_CLOCK  );
    wrtPrtPort(prt_image);
    { data should  not be present }
    if 0 = ( rdPrtPort and PP_RD_DATA )
    then
    begin
      cmd := cmd shr 1 ;
    end
    else
    begin
      cmd := cmd shr 1 ;
      cmd := cmd or $4000 ;
    end;
  END;
  rdData := cmd and $3FFF;
end;

procedure dumpDataMem;
var
  cnt1,cnt2:integer;
begin
  writeln;
  writeln('--Data Mem------------------------------------------------------');
  Apply5V;
  Remove5VandVPP;
  Apply5V;
  Apply5VandVPP;
  delay(DELAY_SHORT);
  for cnt1 := 0 to 7 do
  begin
    for cnt2 := 0 to 7 do
    begin
      wrtCmd(RD_DATA_MEM);
      temp := rdData;
      wrtCmd(INC_ADDR);
      write( tohex(temp):3);
      delay(DELAY_LONG);
    end;
    writeln;
  end;
  Remove5VandVPP;
end;


procedure dumpProgMem;
var
  cnt1,cnt2:integer;
begin
  writeln;
  writeln('--Prog Mem------------------------------------------------------');
  Apply5V;
  Remove5VandVPP;
{  Apply5V; }
  Apply5VandVPP;
  delay(DELAY_SHORT);
  for cnt1 := 0 to 256 do
  begin
    for cnt2 := 0 to 7 do
    begin
      wrtCmd(RD_PRG_MEM);
      temp := rdData;
      write( ' ',tohex(hi(temp)),tohex(temp));
      wrtCmd(INC_ADDR);
    end;
    writeln;
  end;
  Remove5VandVPP;
end;

procedure dumpConfMem;
var
  cnt1,cnt2:integer;
begin
  writeln;
  writeln('--Config Mem----------------------------------------------------');
  Apply5V;
  Remove5VandVPP;
  Apply5V;
  Apply5VandVPP;
  delay(DELAY_LONG);
  wrtCmd( LD_CONF );
  wrtData( $3FFF );
  for cnt1 := 0 to 1 do
  begin
    for cnt2 := 0 to 7 do
    begin
      wrtCmd(RD_PRG_MEM);
      temp := rdData;
      write( ' ',tohex(hi(temp)),tohex(temp));
      wrtCmd(INC_ADDR);
    end;
    writeln;
  end;
  Remove5VandVPP;
end;

procedure Unprotect;
begin
  Apply5V;
  Remove5VandVPP;
  Apply5V;
  Apply5VandVPP;
  delay(DELAY_LONG);


  { Bulk Erase }

  { $2000}
end;


Procedure ProcessFile( filename: string );
var
  cnt,cnt2,address,rectype,data,code,current,hiByte,loByte,conf,temp:integer;
  ipStr,cntStr,addrStr,rectypeStr,dataStr,subDataStr : string;
  finished : boolean;
  ConfigData : array[0..16] of integer;
  f : text;
begin
  for cnt := 0 to 16 do
  begin
    ConfigData[cnt] := -1;
 end;
  assign(f,filename);
  reset(f);
  finished := false;
  DSstate  := DSunknown;
  current := $3FFF;
  while ( not finished ) do
  begin
{
    readln;
}

    readln(f,ipstr);
    if ':' =copy(ipstr,1,1) then
    begin
      cntStr     := copy(ipstr,2,2);
      addrStr    := copy(ipstr,4,4);
      rectypeStr := copy(ipstr,8,2);
      dataStr    := copy(ipstr,10,length(ipStr));
      { need to get next bytes }
{
      writeln(ipstr);
      writeln( cntStr:3,addrStr:5,rectypeStr:3);
}

      if rectypeStr = '01' then finished := true;

      if rectypeStr = '00' then
      begin
        Val('$'+cntStr,cnt,code);

        Val('$'+addrStr,address,code);
        address := address div 2;
        if address < $2000 then
        begin
          if DSstate <> DSprog then
          begin
            DSstate := DSprog;
            { reset to program data mem }
            writeln('Reset Program Mem');
            current := 0;

            Apply5V;
            Remove5VandVPP;
            Apply5V;
            Apply5VandVPP;
            delay(DELAY_LONG);

          end;
          { a line of Program }
          { check if current address equals address }
          if current <> address then
          begin
            { align data }
            if current > address then
            begin
              { reset to program data mem }
              writeln('Reset Program Mem');
              current := 0;
            end;
            if current < address then
            begin
              while current < address do
              begin
                writeln('Inc Add');
                wrtCmd(INC_ADDR);
                current := current + 1;
              end;
            end;
          end;
          { program }
          begin
            write('Program Words[',current,']: ');
            cnt := cnt div 2 ;
            for cnt2 := 0 to cnt -1 do
            begin
              val('$' + copy(dataStr,cnt2*4+1,2),LoByte,code);
              val('$' + copy(dataStr,cnt2*4+3,2),hiByte,code) ;
              write( toHex(hiByte),toHex(loByte),' ');

              wrtCmd( LD_PRG_MEM );
              delay(10);
              wrtData( hiByte*256+loByte );
              wrtCmd( PROG );
              delay(DELAY_LONG);
              wrtCmd(RD_PRG_MEM);
              delay(10);
              temp := rdData;
              if temp <> hiByte*256+loByte then
              begin
                writeln( 'Prog Error:',temp,'<>',hiByte*256+loByte);
                error_flag := true;
              end;

              wrtCmd(INC_ADDR);
              current := current + 1;
            end;
            writeln;
          end;
        end
        else
        if address < $2008 then
        begin
          { do ID and Config word together }
          if DSstate <> DSid then
          begin
            DSstate := DSid;
            { reset to program data mem }
            writeln('Reset ID Mem');
            current := $2000;
{
|       Delay progam until the end as once protected,
|       you cannot program chip!!!
}
{
            Apply5V;
            Remove5VandVPP;
            Apply5V;
            Apply5VandVPP;
            delay(DELAY_LONG);
            wrtCmd( LD_CONF   );
            wrtData( $3FF1 );
            delay(DELAY_LONG);
}
          end;

          { a line of ID }
          writeln('ID word');
          { check if current address equals address }
          if current <> address then
          begin
            { align data }
            if current > address then
            begin
              { reset to program data mem }
              writeln('Reset ID Mem');
              current := $2000;
            end;
            if current < address then
            begin
              while current < address do
              begin
                writeln('Inc Add');
{
                wrtCmd(INC_ADDR);
}
                current := current + 1;
              end;
            end;
          end;

          begin
            write('ID Word[',current,']:');
            cnt := cnt div 2 ;
            for cnt2 := 0 to cnt -1 do
            begin
              val('$'+copy(dataStr,cnt2*4+1,2),LoByte,code);
              val('$'+copy(dataStr,cnt2*4+3,2),HiByte,code) ;
              write( toHex(hiByte),toHex(loByte),' ');
              { program except the config word, just incase it protects }
              { warning, if it protects the code then eeprom data will not work }
              ConfigData[Current-$2000] :=  hiByte*256+loByte;

{
              wrtCmd( LD_PRG_MEM );
              wrtData( hiByte*256+loByte );
              wrtCmd( PROG );
              delay(DELAY_LONG);
              wrtCmd(RD_PRG_MEM);
              temp := rdData;
              if temp <> hiByte*256+loByte then
              begin
                writeln( 'Prog Error:',temp,'<>',hiByte*256+loByte);
                error_flag := true;
              end;
              wrtCmd(INC_ADDR);
}
              current := current + 1;
            end;
            writeln;
          end
        end
        else
        { EEPROM data }
        if address >= $2100 then
        begin
          if DSstate <> DSeeprom then
          begin
            DSstate := DSeeprom;
            { reset to program data mem }
            writeln('Reset Data Mem');

            Apply5V;
            Remove5VandVPP;
            Apply5V;
            Apply5VandVPP;
            delay(DELAY_LONG);

            current := $2100;
          end;
          { a line of EEPROM Data }
          { check if current address equals address }
          if current <> address then
          begin
            { align data }
            if current > address then
            begin
              { reset to program data mem }
              writeln('Reset Data Mem');
              current := $2100;
            end;
            if current < address then
            begin
              while current < address do
              begin
                writeln('Inc Add');
                wrtCmd(INC_ADDR);
                current := current + 1;
              end;
            end;
          end;

          begin
            write('EEPROM Word[',current,']:');
            cnt := cnt div 2 ;
            for cnt2 := 0 to cnt -1 do
            begin
              val('$'+copy(dataStr,cnt2*4+1,2),LoByte,code);
              val('$'+copy(dataStr,cnt2*4+3,2),HiByte,code) ;
              write( toHex(hiByte),toHex(loByte),' ');

              wrtCmd( LD_DATA_MEM );
              wrtData( loByte );
              wrtCmd( PROG );
              delay(DELAY_LONG);
              wrtCmd(RD_DATA_MEM);
              temp := rdData and $FF;
              if temp <> hiByte*256+loByte then
              begin
                writeln( 'Prog Error:',temp,'<>',hiByte*256+loByte);
                error_flag := true;
              end;
              wrtCmd(INC_ADDR);
              current := current + 1;
            end;
            writeln;
          end
        end;
      end;
    end;
  end;
  { Program the Config memory - delayed from earlier }
  begin
    writeln(' Programming Config words ');
    DSstate := DSid;
    { reset to program data mem }
    writeln('Reset ID Mem');
    current := $2000;

    Apply5V;
    Remove5VandVPP;
    Apply5V;
    Apply5VandVPP;

    delay(DELAY_LONG);
    wrtCmd( LD_CONF   );
    wrtData( $3FF1 );
    delay(DELAY_LONG);
    for cnt := 0 to 16 do
    begin
      if ConfigData[cnt] <> -1 then
      begin
        wrtCmd( LD_PRG_MEM );
        wrtData( ConfigData[cnt] );
        wrtCmd( PROG );
        delay(DELAY_LONG);
        wrtCmd(RD_PRG_MEM);
        temp := rdData;
        if temp <> ConfigData[cnt] then
        begin
          writeln( 'Prog Error:',temp,'<>',ConfigData[cnt]);
          error_flag := true;
        end;
      end;
      wrtCmd(INC_ADDR);
    end;
    writeln;
  end;
  close(f);
end;




{
Program Memory
:02 0000 00 0828 CE
:10 0010 00 00308B00FF3086008316FF3086008510 8D
:10 0020 00 05108312640083160130810083128D01 54
:10 0030 00 8C018E0185010C0806180C0A21208C00 09
:10 0040 00 1B28820700340234262802340D088618 43
:10 0050 00 0D0A30208D00900B0034051085100034 FF
:10 0060 00 82070034023400340434003406340034 8F
:10 0070 00 083400340A3400340C344F2800341034 6F
:10 0080 00 00340034123400341434003416340034 94
:10 0090 00 183400341A3400341C34532800340514 46
:0E 00A0 00 FF3090000E348514003090000034 C4

ID bytes
:08 4000 00 0100000000000000 B7

config word
:02 400E 00 FD3F 74
:00 0000 01 FF

:BBAAAATTHHHHHHHH..HHCC
  BB     byte count
  AAAA   Absolute Address by byte, div by 2 for listing address
         Listing Address:-
         0000-03FF        PROG Memory
         2000-2003        ID words
         2007             Config Address
         2100             DATA Memory


  TT     Type :
           00  data record
           01  End of File
           02  Segment address
           04  Linear Address Record
  HH
         Hex in LoHi format

  CC     CheckSum = Sum + CheckSum = 0
}


{ Main Program ...... }

procedure old_dos;
BEGIN
     select_programmer( 0 );
     writeln(' Capturing output....');
     { allow the output to be piped }
     Assign(Output,'');
     Rewrite(Output);
     error_flag := false;

     while true {keypressed }do
     begin
      read
     end;

     prt_image :=PP_DATA or PP_CLOCK or PP_DATA_RD
                { or PP_NVPP } or PP_MONO { or PP_N5Volt };


     wrtPrtPort(prt_image);
     temp := rdPrtPort;
     writeln(temp);
{
     if temp = 128 then
     begin
       writeln(' Fault: Check MEC programmer is connected and powered');
       readln;
       halt(1);
     end;
}
{
     delay11ms;
     delay11ms;
     delay11s;
}


     dumpDataMem;
     dumpProgMem;
     dumpDataMem;
     dumpConfMem;
     if ParamCount > 0 then
     begin
       if ParamStr(1) = 'last' then
       begin
         assign(ipFile,'procpic.ini');
         reset(ipfile);
         readln(ipfile,fileName);
         close(ipfile);
         writeln(' Programming from :',fileName);
         delay(1000);
         Unprotect;
         ProcessFile(fileName);
       end
       else
       if ParamStr(1) <> 'dump' then
       begin
         assign(ipFile,'procpic.ini');
         rewrite(ipfile);
         writeln(ipfile,ParamStr(1));
         close(ipfile);
         Unprotect;
         ProcessFile(ParamStr(1));
       end;
     end;

     Apply5V;
     Remove5VandVPP;
     Apply5V;

     Apply5VandVPP;
{
     delay11ms;
     delay11ms;
{     delay11s; }
{
     LD_CONF     = $00;
     LD_PRG_MEM  = $02;
     RD_PRG_MEM  = $04;
     INC_ADDR    = $06;
     PROG        = $08;
     LD_DATA_MEM = $03;
     RD_DATA_MEM = $05;
     ERASE_PROG  = $09;
     ERASE_DATA  = $0B;
     DIS_PROTECT1= $01;
     DIS_PROTECT2= $07;
}
     writeln;
     dumpProgMem;
     dumpDataMem;
     dumpConfMem;
     Remove5VandVPP;
     if  error_flag = true
     then
         writeln(' There have been programming errors')
     else
         writeln(' There have no programming errors');

     writeln;
     writeln( ' Usage: PROCPIC            - dump contents of chip');
     writeln( ' Usage: PROCPIC file.HEX   - program chip');
     writeln( ' Usage: PROCPIC last       - program chip, filename in PROGPIC.INI');
  end;

{$ENDIF}

end.
