{
  This file contains libary functions so move code out of the timer
}

unit ppDelpPL; { prefix PL }

interface

function PL_test( cmd:integer): integer;


{ ---- moved from ppdelp, but uses ppdelp for low level -----}

procedure Apply5VandVPP;
procedure Apply5V;
procedure Remove5VandVpp;

procedure wrtCMD(cmd:integer);
procedure wrtData(cmd:integer);
function  rdData:integer;


{ IIC functions }
procedure ApplyIICpower;
procedure ApplyIICStart;
procedure ApplyIIC_zero;
procedure ApplyIIC_one;
procedure ApplyIICStop;
function readIICbit:boolean;
function readIICbyte:integer;
function writeIICbyte( value:integer ):boolean;


implementation

uses ppdelp;

function PL_test( cmd:integer): integer;
begin
  pl_test := cmd + cmd ;
end;


{
function readIICbit:boolean;
begin
  setData;
  setClk;
  setClk;
  readIICbit := rdDataBit;
  resetClk;
  resetData;
end;
}



procedure Apply5VandVPP;
begin
  setVPP;
   if NeedsWait then
      wrtCmd(  $20 );
end;

procedure Apply5V;
begin
  setVPP;
  if NeedsWait then
    wrtCmd(  $22 );
end;

procedure Remove5VandVpp;
begin
 resetVPP;
 if NeedsWait then
   wrtCmd(  $23 );
end;


{ -----------------------------------------------------------}

procedure wrtCMD(cmd:integer);
var
  cnt : byte;
begin
  { zero bits }
  resetData;
  resetClk;
  for cnt := 0 to 5 do
  BEGIN
    if 0 = ( cmd and 1 )
    then
    begin
      resetData;
    end
    else
    begin
      setData;
    end;
    setClk;
    resetClk;
    cmd := cmd shr 1 ;
  END;
  { Turn data line into input, just incase command is read }
end;

procedure wrtData(cmd:integer);
var
  cnt : byte;
begin
  { zero bits }
  cmd := cmd shl 1;
  for cnt := 0 to 15 do
  BEGIN
    if 0 = ( cmd and 1 )
    then
    begin
      resetData;
    end
    else
    begin
      setData;
    end;
    setClk;
    resetClk;
    cmd := cmd shr 1 ;
  END;
end;

function rdData:integer;
var
  cnt : byte;
  cmd : integer;
  readBit : boolean;
begin
  cmd := 0;
  resetData;
  resetClk;
  { Clock one bit }
  setClk;
  resetClk;
  for cnt := 0 to 14 do
  BEGIN
    setData; { Bias the PIC }
    setClk;
    { data is being presented }
    { data should  not be present }
    if NeedsWait then
       readBit := rdDataOBit
       else
       readBit := rdDataBit;
    if not readBit
    then
    begin
      cmd := cmd shr 1 ;
    end
    else
    begin
      cmd := cmd shr 1 ;
      cmd := cmd or $4000 ;
    end;
    resetClk;
  END;
  rdData := cmd and $3FFF;
end;


{---------------------------------------------------------------------------}
{ MicroChip 24C08B/16B functions }

{
     iiC principles:
     Only change data while clk is low
     so
     Start bit is signified by taking Data low while clk is high
     Stop  bit is signified by taking Data high while clk is high

     Start:
           clk   ---\____
           data  --\____

     0:
           clk   __/--\__
           data  ________

     0:
           clk   ____/--\________
           data  _/--------\_____


     Stop:
           clk   __/--------
           data  ___/-------




  }

procedure ApplyIICpower;
begin
  setVPP;
  setData;
  setClk;
  {apply power }
  setVPP;
end;

procedure ApplyIICStart;
begin
{
SDA X-----____
SCK XX-----___
}

{  resetClk; }
  setData;
  setClk;
  resetData;
  resetClk;
end;

procedure ApplyIIC_zero;
begin
  resetData;
  setClk;
  setClk;
  resetClk;
  resetData;
end;


procedure ApplyIIC_one;
begin
  setData;
  setClk;
  setClk;
  resetClk;
  resetData;
end;


procedure ApplyIICStop;
begin
{
SDA X_____--
SCK XX__----
}

  resetData;
  resetClk;
  setClk;
  setClk;
  setData;
end;

{--- testDHR ---}

function readIICbit:boolean;
begin
  setData;
  setClk;
  setClk;
  readIICbit := rdDataBit;
  resetClk;
  resetData;
end;

function readIICbyte:integer; { read Byte with no ACK }
var
  cnt: integer;
  temp : integer;
begin
  temp := 0;
  { MSB first }
  for cnt := 0 to 7 do
  begin
    if readIICbit then
      temp := temp + temp + 1
    else
      temp := temp + temp;
  end;
  readIICbyte := temp;
end;

function writeIICbyte( value:integer ):boolean;
var
  cnt: integer;
  temp : integer;
  pwr2 : integer;
begin
  temp := value;
  pwr2 := 1;
  { MSB first }
  for cnt := 0 to 7 do
  begin
    if ( temp and $80 ) <> 0 then
      ApplyIIC_one
    else
      ApplyIIC_zero;

    temp := temp shl 1
  end;
  { read ACK }
  writeIICbyte := readIICbit;
end;







end.
