{
| This code uses the Buffer PIC to Program
| the 16F84 and 16F877 PIC chips.
| Currently, the PIC16F877 requires the use
| of the command $18,No erase and Program.
}


unit ppdelp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, Buttons, IniFiles,Registry,

  { Grids, }

  CommDrv,
  pic_prog_About ,
  ppProgSpecials,
  pic_prog_delph,
  ppDelpPL   ;


type
  TForm1 = class(TForm)
    Label1:            TLabel;
    MProg:             TMemo;
    Label2:            TLabel;
    MData:             TMemo;
    Label3:            TLabel;
    MFuses: TMemo;
    MainMenu1: TMainMenu;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Label4: TLabel;
    SaveDialog1: TSaveDialog;
    File2: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs2: TMenuItem;
    Save3: TMenuItem;
    Open2: TMenuItem;
    New1: TMenuItem;
    Edit2: TMenuItem;
    Object2: TMenuItem;
    Links2: TMenuItem;
    N8: TMenuItem;
    GoTo2: TMenuItem;
    Replace2: TMenuItem;
    Find2: TMenuItem;
    N9: TMenuItem;
    PasteSpecial2: TMenuItem;
    Paste2: TMenuItem;
    Copy2: TMenuItem;
    Cut2: TMenuItem;
    N10: TMenuItem;
    Repeatcommand2: TMenuItem;
    Undo2: TMenuItem;
    Button5: TButton;
    Timer1: TTimer;
    Button6: TButton;
    Button7: TButton;
    BitBtn1: TBitBtn;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    ReopenLast1: TMenuItem;
    Button2: TButton;
    Label7: TLabel;
    Label8: TLabel;
    LBchipId: TLabel;
    Label10: TLabel;
    About1: TMenuItem;
    CommPortDriver1: TCommPortDriver;
    Button1: TButton;
    ComboBox1: TComboBox;
    Button3: TButton;
    Label11: TLabel;
    Edit1: TEdit;
    Label12: TLabel;
    Button16: TButton;
    CB_inc_prog: TCheckBox;
    CB_inc_data: TCheckBox;
    CB_inc_conf: TCheckBox;
    RG_device: TRadioGroup;
    Label5: TLabel;
    Label6: TLabel;
    Memo2: TMemo;
    Button18: TButton;
    CB_inc_reload: TCheckBox;
    CB_inc_erase: TCheckBox;
    LBMaxMem: TLabel;
    OscCal: TCheckBox;
    Edit5: TEdit;
    timerTick: TEdit;
    Edit3progMemMax: TEdit;
    Edit4dataMemMax: TEdit;
    Label9: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Edit5fuseMemMax: TEdit;
    Label16: TLabel;
    procedure Open2Click(Sender: TObject);
    procedure Save3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure ReopenLast1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure file11Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);

    procedure Button16Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);

  private

    ts      : TdateTime;
    tsNow   : TdateTime;
    tsLast  : TdateTime;



    IICaddr  :integer;
    IICdata  :integer;
    IICstring : string;
    IICcounter :integer;
    { Private declarations }
    procedure processMemo;
    procedure InitButtonStates;

    procedure timerEraseOne;

    procedure timerApplyPower;

    procedure timer1Erase( state_offset:integer);
    procedure timer1Program( state_offset:integer);



    { in include file ppdelphInclude.pas }
    procedure timer1Template( state_offset:integer);
    procedure timer1PIC16F88( state_offset:integer);
    procedure timer1IIC;
    procedure timer1CrownHill;



  public
    { Public declarations }

  end;

type
  progModeT = ( readData, readProg,readFuses,
                bulkEraseProg,bulkEraseData,bulkEraseBoth,
                progProg,progData,progFuses
              );





{
 TABLE 3-1: COMMAND MAPPING FOR PIC10F200/202/204/206
Command Mapping (MSb  LSb) Data
Load Data for Program Memory     x x 0 0 1 0    0, data (14), 0
Read Data from Program Memory    x x 0 1 0 0    0, data (14), 0
Increment Address                x x 0 1 1 0
Begin Programming                x x 1 0 0 0 Externally Timed
End Programming                  x x 1 1 1 0
Bulk Erase Program Memory        x x 1 0 0 1 Internally Timed
}

const
     LD_CONF       = $00;
     LD_PRG_MEM    = $02;
     RD_PRG_MEM    = $04;
     INC_ADDR      = $06;
     PROG          = $08;
     BEGIN_ERASE   = $08;
     PROG_NO_ERASE = $08; { $18 }  { on 12F675 PRO externally timed }

     PROG_STOP   = $0E;
     LD_DATA_MEM = $03;
     RD_DATA_MEM = $05;
     ERASE_PROG  = $09;
     ERASE_DATA  = $0B;

     BEGIN_PROG  = $18;
     END_PROG    = $17;



     CHIP_ERASE  = $1F;

     DIS_PROTECT1= $01;
     DIS_PROTECT2= $07;

     Voff          = $20;
     Vpp           = $21;
     V5VnVpp       = $22;
     V5VVpp        = $23;
     VInvAllOff    = $24;
     VInv5V        = $25;
     VInv5VVpp     = $26;
{
     ; The XX only apply to the 16F877
;
;	Specials for turning on the +5 volts and 5 Vpp
;
;all Off			100000
;Vpp On				100001
;+5  On,Vpp Off			100010
;+5  On,Vpp On			100011
;
;

}

var
  Form1        : TForm1;
  HexData,ChipData      : HexDataT;
  chipAddress  : integer;
  state,temp   : integer;
  savedState   : integer;
  cnt1,cnt2,cnt3    : integer;
  progMode     : progModeT;

  progChip     : Boolean ;
  progMemMax   : integer;
  dataMemMax   : integer;
  fuseMemMax   : integer;

  progChipProgress : progModeT ;

  opStr        : string;
  dwEvtMask    : DWORD;
  Errors       : boolean;
  BlankChip    : boolean;
  ChipSame     : boolean;
  DataSame     : boolean;
  FileName     : string;
  FileNameA    : array[0..4] of string;
  IniFile      : TRegIniFile;
  NeedsWait    : boolean;


  { temporary values }

  commRet : integer;



{ Public declarations }

 function rdDataBit:boolean;
 function rdClkOBit:boolean;
 function rdDataOBit:boolean;

 procedure setClk;
 procedure resetClk;
 procedure setData;
 procedure resetData;
 procedure setVPP;
 procedure resetVPP;



implementation

uses ppdelp;

{$R *.DFM}





procedure TForm1.Open2Click(Sender: TObject);
var
   cnt, cnt2 : integer;
begin
  OpenDialog1.FileName := '*.hex';
  if OpenDialog1.Execute then
  begin
    if FileExists( OpenDialog1.FileName ) Then
      Memo1.Lines.LoadfromFile(OpenDialog1.FileName);


    SaveDialog1.Filename := OpenDialog1.FileName;
    Caption := OpenDialog1.FileName;
    Filename := OpenDialog1.FileName;
    FilenameA[4] := FilenameA[3];
    FilenameA[3] := FilenameA[2];
    FilenameA[2] := FilenameA[1];
    FilenameA[1] := FilenameA[0];
    FilenameA[0] := Filename;

    ComboBox1.Items.Strings[0] := FilenameA[0];
    ComboBox1.Items.Strings[1] := FilenameA[1];
    ComboBox1.Items.Strings[2] := FilenameA[2];
    ComboBox1.Items.Strings[3] := FilenameA[3];
    ComboBox1.Items.Strings[4] := FilenameA[4];

    IniFile.WriteString('files','lastFile0',FileNameA[0]);
    IniFile.WriteString('files','lastFile1',FileNameA[1]);
    IniFile.WriteString('files','lastFile2',FileNameA[2]);
    IniFile.WriteString('files','lastFile3',FileNameA[3]);
    IniFile.WriteString('files','lastFile4',FileNameA[4]);

    IniFile.WriteInteger('device','LastDevice',LongInt(RG_device.ItemIndex) );

    IniFile.WriteString('progMemMax','LastProgMemMax',Edit3progMemMax.text );
    IniFile.WriteString('dataMemMax','LastDataMemMax',Edit4dataMemMax.text );
    IniFile.WriteString('fuseMemMax','LastFuseMemMax',Edit5fuseMemMax.text );


    ComboBox1.Items.Insert( 0, Filename );
    ComboBox1.text :=  Filename ;

    processMemo;
  end;
end;

procedure TForm1.Save3Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
  begin
    // if FileExists( OpenDialog1.FileName ) Then
    Memo1.Lines.LoadfromFile(OpenDialog1.FileName);
    SaveDialog1.Filename := OpenDialog1.FileName;
    Caption := OpenDialog1.FileName;
  end;
end;

{
; The Crownhill is a serial port programmer.
; TXD -> VPP and +5, To apply, Set the BREAK to apply continously
; DTR -> Data to
; RTS -> Clock
; CTS <- Data from PIC
;
;
}

function ConnectComPort:boolean;
begin

{  Form1.CommPortDriver1.ComPort:= pnCOM1 ; }
  Form1.CommPortDriver1.ComPort:= TComPortNumber( StrToInt( Form1.Edit1.Text ) - 1 ) ;
  Form1.CommPortDriver1.Connect;
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    dwEvtMask := 0;

    SetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    ConnectComPort := true
  end
  else
  begin
    ConnectComPort := false
  end;
end;

procedure DisConnectComPort;
begin
  Form1.CommPortDriver1.ComPort:= pnCOM5 ;
  Form1.CommPortDriver1.Connect;
  if Form1.CommPortDriver1.Connected then
  begin

   { dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD; }

    dwEvtMask := not EV_CTS  or not EV_DSR or not EV_RING  or not EV_RLSD;

    SetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    Form1.CommPortDriver1.Disconnect;
  end;
end;

{---------------- BITS to toggle Commport lines --------------------------}

function rdDataBit:boolean;
var
   ret : boolean;
   a : TCOMSTAT;
   dwEvtMask: DWORD;
   lpModemStat: DWORD;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    ret := GetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    ret := GetCommModemStatus(Form1.CommPortDriver1.FComPortHandle, lpModemStat);
    commRet := lpModemStat;
    rdDataBit :=  (  $0010 = ( lpModemStat and ( $0010 ) ) ) ;
  end;
end;

function rdClkOBit:boolean;
var
   ret : boolean;
   a : TCOMSTAT;
   dwEvtMask: DWORD;
   lpModemStat: DWORD;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    ret := GetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    ret := GetCommModemStatus(Form1.CommPortDriver1.FComPortHandle, lpModemStat);
    commRet := lpModemStat;
    rdClkOBit :=  (  $0020 = ( lpModemStat and ( $0020 ) ) ) ;
  end;
end;

function rdDataOBit:boolean;
var
   ret : boolean;
   a : TCOMSTAT;
   dwEvtMask: DWORD;
   lpModemStat: DWORD;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    ret := GetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    ret := GetCommModemStatus(Form1.CommPortDriver1.FComPortHandle, lpModemStat);
    commRet := lpModemStat;
    rdDataOBit :=  (  $0080 = ( lpModemStat and ( $0080 ) ) ) ;
  end;
end;



procedure setClk;
var
   count : integer;
begin
  count := 0;
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,SETRTS);
  repeat until ( rdClkOBit or NOT  NeedsWait )  ;
  end;
  Form1.Label7.caption := IntToStr( count );
end;

procedure resetClk;
var
   count : integer;
begin
  count := 0;
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,CLRRTS);
    repeat until ( not rdClkOBit or NOT  NeedsWait )  ;
  end;
  Form1.Label8.caption := IntToStr( count );
end;

procedure setData;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,SETDTR);
  end;
end;

procedure resetData;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,CLRDTR);
  end;
end;


procedure setVPP;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    SetCommBreak( Form1.CommPortDriver1.FComPortHandle);
  end;
end;

procedure resetVPP;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    ClearCommBreak( Form1.CommPortDriver1.FComPortHandle);
  end;
end;




{-------------------------------------------------------------------------}

procedure TForm1.Button5Click(Sender: TObject);
var
  cnt1,cnt2,temp:integer;
begin
  MProg.lines.clear;
  progMode := readProg;
  progChip := False ;

  state := 1;
end;



procedure TForm1.InitButtonStates;
begin
       NeedsWait       := FALSE;

       Button1.enabled  :=false;
       Button2.enabled  :=false;
       Button3.enabled  :=false;
       Button5.enabled  :=false;

       Button6.enabled  :=false;
       Button7.enabled  :=false;
       Button9.enabled  :=false;
       Button10.enabled :=false;

       Button11.enabled :=false;
       Button12.enabled :=false;

       Button16.enabled :=false;


       BitBtn1.enabled  :=true;

       Form1.Cursor   :=  crHourGlass;
       Label5.caption := 'Programming...';

       BlankChip    := TRUE;
       ChipSame     := TRUE;
       DataSame     := TRUE;

       Remove5VandVPP;
       resetData;
       resetClk;

end;

{------------------------------------------------------------------------}
procedure TForm1.timerEraseOne;
begin
  Memo1.lines.add( '....timerEraseOne....' );

end;

procedure TForm1.timerApplyPower;
begin
  Memo1.lines.add( '....timerEraseOne....' );
  Label6.caption := '---Pwr---' ;
  Label6.color := clYellow ;


    case state of
    1:





     { Put the chip into programme mode }
     Begin
       InitButtonStates;
       if ConnectComPort then
       begin
         { zero bits }
         resetData;
         resetClk;
         Remove5VandVPP;
         state  := state +1;
         Label11.caption := '';

       end
       else
       begin
         Label11.caption := 'Error: COM Port in use...';
         state  := $1000;
       end

     end;

     3:
     Begin
       resetData;
       resetClk;
       Apply5V;
       state  := state +1;
       Label5.caption := 'Programming...';
       Timer1.Interval := 50; {ms}
     end;

     10:
     {
     With 5volts on Chip, bounce MCLR/VPP pin,
     Programming mode is entered if
     data and Clk = 0 when Vpp raised to 12 volts.
     Most 16F84 seems to programme well outside
     the spec.
     }
     Begin
       resetData;
       resetClk;
       Remove5VandVPP;
       state  := state +1;
     end;

     11:
     {
     With 5volts on Chip, bounce MCLR/VPP pin,
     Programming mode is entered if
     data and Clk = 0 when Vpp raised to 12 volts.
     Most 16F84 seems to programme well outside
     the spec.
     }
     Begin
       resetData;
       resetClk;
       Remove5VandVPP;
       state  := 12;
     end;


     { progress with a bit of delay }
     12:
     Begin
       resetData;
       resetClk;
       Apply5V;
       state  := state +1;
     end;

     20:
     Begin
       Timer1.Interval := 25; {ms}

       resetData;
       resetClk;
       Apply5VandVPP;
       state  := state +1;
       cnt1:=0;
       cnt2:=0;

       case progMode of
           readData:       MData.lines.add('.............');
           readProg:       MProg.lines.add('.............');
           readFuses:      MFuses.lines.add('.............');
           bulkEraseData:  MData.lines.add('..erase......');
       else
       end;
       opStr  := '';
     end;
     else
       state := state+1;
  end;

end;


{$I ppdelpInclude.pas}

procedure TForm1.timer1Erase( state_offset:integer );
begin
{
    // do a bulk erase of both
    bulkEraseProg: state := $A00;
    bulkEraseData: state := $A10;
    bulkEraseBoth: state := $A20;
}

  case state - state_offset of
     { states }
     $A00:  { bulk erase }
     begin

       case RG_device.ItemIndex of
       2: { 10F204 }
       Begin
         Memo1.lines.add( ' ..Erasing 10F204..');
         wrtCmd( ERASE_PROG );
         state := $1000;
       end;

       3: { 16F688 }
       begin
         Memo1.lines.add( ' ..Erasing 16F88..');
         wrtCmd( LD_CONF );
         wrtData( $3FFF );
         wrtCmd( LD_PRG_MEM );    { $2000 }
         wrtData( $0001 );
         wrtCmd( CHIP_ERASE );
         state := $1000;
       end
       else
       begin  { 10F204 } { 12F675 }
         Memo1.lines.add( ' ..Adding CodeProtection...');
         {
         * Apply Code protection,
         * so that the remove code protection also clears prog and data memory
         }
         wrtCmd( LD_CONF );    { $2000 }
         wrtData( $0000 );
         wrtCmd(INC_ADDR);     { $2001 }
         wrtCmd(INC_ADDR);     { $2002 }
         wrtCmd(INC_ADDR);     { $2003 }

         wrtCmd(INC_ADDR);     { $2004 }
         wrtCmd(INC_ADDR);     { $2005 }
         wrtCmd(INC_ADDR);     { $2006 }
         wrtCmd(INC_ADDR);     { $2007 }
         wrtCmd( PROG );
         state  := state + 1;
       end;
       end; { case RG_device.ItemIndex of }

     end;
     $A02:            { bulk erase }
     begin
       Remove5VandVPP;
       resetData;
       resetClk;
       state  := state + 1;
     end;

     $A04:            { bulk erase }
     begin
       Apply5VandVPP;
       state  := state + 1;
     end;

     $A08:            { bulk erase }
     begin
       Memo1.lines.add( ' ..RemovingCodeProtection...');
       wrtCmd( LD_CONF );    { $2000 }
       wrtData( $3FFF );

       wrtCmd(INC_ADDR);     { $2001 }
       wrtCmd(INC_ADDR);     { $2002 }
       wrtCmd(INC_ADDR);     { $2003 }

       wrtCmd(INC_ADDR);     { $2004 }
       wrtCmd(INC_ADDR);     { $2005 }
       wrtCmd(INC_ADDR);     { $2006 }
       wrtCmd(INC_ADDR);     { $2007 }

       wrtCmd( DIS_PROTECT1);
       wrtCmd( DIS_PROTECT2);
       wrtCmd( PROG );
       state  := state + 1;

     end;

     $A0A:
     begin
       Memo1.lines.add( ' ..CodeProtectEnd...');

       { finish off code protection removal }
       wrtCmd( DIS_PROTECT1);
       wrtCmd( DIS_PROTECT2);

       Remove5VandVPP;
       resetData;
       resetClk;
       //state := $1000;
       state := $C00;
     end;



     $A0D:
     begin
       Memo1.lines.add( ' ..erase Prog...');
       { do a bulk erase of data memory }
       { State := $A09; }
       wrtCmd( LD_DATA_MEM );
       wrtData( $FFFF );
       wrtCmd( ERASE_PROG );
       wrtCmd( PROG );
       state  := state + 1;
     end;

     $A10:
     begin
       Memo1.lines.add( ' ..erase Data...');

       { do a bulk erase of program memory }
       { State := $A09; }
       wrtCmd( LD_DATA_MEM );
       wrtData( $FFFF );
       wrtCmd( ERASE_DATA );
       wrtCmd( PROG );
       state  := state + 1;
     end;


     $A14:            { bulk erase }
     begin
       Memo1.lines.add( ' ..end of Bulk Erase Chip...');
       Remove5VandVPP;
       resetData;
       resetClk;
       state  := state + 1;
     end;

     $A18:
     begin
       state := $1000;
     end;

     $A20:  { do a bulk erase of program memory }
     begin
       Memo1.lines.add( ' ..erase Data...');
       { do a bulk erase of program memory }
       { State := $A09; }
       wrtCmd( LD_CONF );

       wrtData( $0000 );
       wrtCmd( ERASE_PROG );

       state  := state + 1;
     end;

     $A30:
     begin
       Memo1.lines.add( ' ..erase Data...');

       { do a bulk erase of program memory }
       { State := $A09; }
       wrtCmd( LD_CONF );

       wrtData( $0000 );
       wrtCmd( ERASE_DATA );

       state  := state + 1;
     end;

     $A40:
     begin
       Memo1.lines.add( ' ..erase Data...');

       { do a bulk erase of program memory }
       { State := $A09; }
       wrtCmd( LD_CONF );

       wrtData( $0000 );
       wrtCmd( ERASE_DATA );

       state  := $1000;
     end;

  else
    state := state + 1;
  end;
end;


procedure TForm1.timer1Program( state_offset:integer );
begin

  case state - state_offset of
     { states }
     $20A: { IIC function}
     begin
       state := state + 1;
     end;
  else
    state := state + 1;
  end;
end;


{
Need routines to do:
   load file:
   bulkErase( chip Type ):
   progProg( chip Type ):
   progData( chip Type ):
   progFusesData( chip Type ):

Need a flag to enable each
Need a Flag to program list called progChip.

If progChip

   loadFile  -> bulkErase
   BulkErase -> progProg
   progProg -> progData
   progData -> progFuseData

   else finish at end of routine

   loadFile  -> bulkErase
   BulkErase -> finish
   progProg  -> finish
   progData  -> finish


 }



procedure TForm1.Timer1Timer(Sender: TObject);
var
  finished :boolean;
  skipped  :boolean;
  skippedCnt :integer;
  bit      :boolean;
  temp     :integer;
  cnt      :integer;
  cnt2     :integer;
  nackSeen :boolean;
  memSize  :integer;
  getTicks :dword;

  byteStr : string;

  Col,Row :integer;

  tsStr   : string;
  code    : integer;

 begin

   if Form1.CommPortDriver1.Connected then
     label11.caption :='connected'
   else
     label11.caption :='not connected, may be in use elsewhere.'     ;

     if  state > 0 then
     begin
       Memo2.lines.add( ' state: ' + intToHex( state,4)+' modem:'+intToHex( commRet,4) );
     end;

     { Timer is used to pause delays }
     Label5.caption := 'State 0x'+intToHex( state,4 );

     case state of
     1..20:
     begin
       case RG_device.ItemIndex of
         0: progMemMax :=  $400 -1;  { 16F84  }
         1: progMemMax :=  $800 -1;  { 12F675 }
         2: progMemMax :=  $100 -1;  { 10F204 }
         3: progMemMax :=  $1000 -1; { 16F88  }
       end; {  case }


      //   progMemMax   : integer;
      //   dataMemMax   : integer;
      //   fuseMemMax   : integer;


      val( Edit3progMemMax.Text,progMemMax,code);

      if code > 0 then
      begin
        progMemMax := $2000
      end;

      val( Edit4dataMemMax.Text,dataMemMax,code);

      if code > 0 then
      begin
        dataMemMax := 256
      end;

      val( Edit5fuseMemMax.Text,fuseMemMax,code);

      if code > 0 then
      begin
        fuseMemMax := $2007
      end;


      timerApplyPower;

     end;

     { branch to different sections on programming mode }
     21:
     begin
       Label6.caption := '---------' ;
       Label6.color := clBtnFace ;

       { Putting the chip into Config area needs extra instructions }
       if progMode = readFuses then
       begin
         Label6.caption := '--Fuses--' ;
         Label6.color := clYellow ;

         wrtCmd(  LD_CONF );
         wrtData( $3FFF );
       end;
       state  := $4F0;

       case progMode of
         readData:      chipAddress := $2100;
         bulkEraseData: chipAddress := $2100;
         readProg:      chipAddress := $0000;
         readFuses:     chipAddress := $2000;
         progProg,progData,progFuses: chipAddress := $0000;
       else
       end;

       chipSame := false;
       dataSame := false;

       case progMode of
         readData: dataSame := true;
         readProg: chipSame := true;
       else
       end;


       case progMode of

         { reading from the chip }
         readData,
         readProg,
         readFuses:
         begin
           //state := $40;
           state := $3F;
         end;

         { bulk erase }
         bulkEraseProg: state := $A00; { do a bulk erase of both }
         bulkEraseData: state := $A10;
         bulkEraseBoth: state := $A20;


         { Program the sections of the chip }
         {
           Should really read Chip Identity.

           Could have list of buttons
           B1 -> B2 -> B3 -> B4 -> B5

           Could have list of operations in memo which you select:

           Buttons:

             ButtonProgChip:
               Does []Reload,[]BulkErase,[]progProg,[]progData,[]ProgFuses

             ButtonReload:

             ButtonBulkErase: Power, BulkErase, finish

             ButtonReadProg:  Power, ReadProg,  finish
             ButtonProgProg:  Power, ProgProg,  finish

             ButtonReadData:  Power, ReadData,  finish
             ButtonProgData:  Power, ProgData,  finish

             ButtonReadData:  Power, ReadFuses,  finish
             ButtonProgFuses: Power, ProgFuses,  finish

             At some point you have to break out for each chip.
             There should be a


         }

         // progProg:  state := $B00;
         {
         |  Branch to the
         |
         |
         |
         }

         progProg:
         begin
           if CB_inc_prog.checked then
             state := $AFC
           else
             state    := $C00;
         end;

         progData:
         begin
           if CB_inc_data.checked then
           begin
             state := $B04;
             if RG_device.ItemIndex = 3 then
             begin
               state := $B14;
             end
           end
           else
             state    := $C00;
         end;


         progFuses:
         begin
           if CB_inc_conf.checked then
           begin
             state    := $B07;
           end
           else
             state    := $C00;
         end;
       else
       end;
     end;


     {---------------------------------------------------------------------}
     { Start reading chip }
     30:
     begin
       case progMode of
         readData:  wrtCmd( RD_DATA_MEM  );
         readProg:  wrtCmd( RD_PRG_MEM  );
         readFuses: wrtCmd( RD_PRG_MEM  );
       else
       end;
       {wrtCmd( RD_PRG_MEM  );}
       temp := rdData;
       if temp <> $3FFF then BlankChip := FALSE;
       if hexData.data[ chipAddress ] <> temp then chipSame :=FALSE;


       chipData.data[ chipAddress ] := temp;
       chipAddress := chipAddress +1 ;

       wrtCmd(INC_ADDR);
       cnt1 := cnt1+1;
       opStr := opStr + ' ' + IntToHex( temp, 4 );
       if cnt1 = 8 then
       begin
         opstr := IntToHex( cnt2,4 )+' : ' + opStr;
         case progMode of
           readData:       MData.lines.add( opStr );
           readProg:       MProg.lines.add( opStr );
           readFuses:      MFuses.lines.add(opStr );
         else
         end;
         opStr := '';
         cnt2  := cnt2+8;
         cnt1  := 0;
       end;

       case progMode of
         readData:   if chipAddress = $2100 + dataMemMax-1 then state := $31;
         readProg:   if chipAddress = progMemMax-1 then state := $31;
         readFuses:  if chipAddress = fuseMemMax-1 then state := $31;
       else
       end;
     end;

     $31:
     Begin
       opstr := IntToHex( cnt2,4 )+' : ' + opStr;
       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;
       opstr := '-----------';
       if blankChip then
       begin
         opstr := opstr +': Blank   Chip ';
       end;
       if chipSame  then
       begin
         opstr := opstr +': Chip == File ';
       end;
       opstr := opStr + ': -----------';

       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;

       case progMode of
         readData:       dataSame := true;
         readProg:       chipSame := true;
         readFuses:
       else
       end;

       Label5.caption := 'Finished';
       state := $1000;
     end;


     { Reading a 10F204 device
       The CONF is available between Reset and first INC_ADDR

       Reading PROG
         reset device
         INC_ADDR
         send RD_PRG_MEM

        Reading DATA
         Not available

        Reading CONF
         reset device
         send RD_PRG_MEM
         INC_ADDR
      }

     { Reading a device

       Reading PROG
         reset device
         send RD_PRG_MEM

        Reading DATA
         reset device
         send RD_DATA_MEM

        Reading CONF
         send LD_CONF
         send RD_PRG_MEM
      }

     $3F:
     begin
       case RG_device.ItemIndex of
       2: { 10F204 devices }
       begin
         { Only available between reset and first INC_ADDRESS }
         wrtCmd( RD_PRG_MEM  );
         temp  := rdData;
         opStr := ' Config fuses: ';

         wrtCmd( INC_ADDR );
         opStr := opStr + ' ' + IntToHex( temp, 4 );
         MProg.lines.add(opStr);
         state := $40;
       end
       else
       begin
         state := $40;
       end;
       end;{case}
       state := $40;
     end;



     $40:
     begin
       case progMode of
         readData:
         begin
           Label6.color := clRed ;
           Label6.caption := '--Rd Data--' ;
         end;

         readProg:
         begin
           Label6.color := clLime ;
           Label6.caption := '--Rd Prog--' ;
         end;

         readFuses:
         begin
           Label6.color := clYellow ;
           Label6.caption := '--Rd Fuses--' ;
         end;
       end;


       opStr :='';
       case progMode of
         readData:  wrtCmd( RD_DATA_MEM  );
         readProg:  wrtCmd( RD_PRG_MEM  );
         readFuses: wrtCmd( RD_PRG_MEM  );
       else

       end;
       temp  := rdData;
       ChipData.data[ chipAddress ] := temp;

       if temp <> $3FFF then BlankChip := FALSE;
       case progMode of
         readData:
           if (hexData.data[ chipAddress ] AND $FF) <> (temp AND $FF) then
           begin
             Memo1.lines.add( IntToHex( chipAddress, 4 )+' :' + IntToHex( hexData.data[ chipAddress ] , 4 )+'!='+ IntToHex( temp , 4 ) );
             dataSame :=FALSE;
           end;
         readProg:
           if hexData.data[ chipAddress ] <> temp then
           begin
             Memo1.lines.add( IntToHex( chipAddress, 4 )+' :' + IntToHex( hexData.data[ chipAddress ] , 4 )+'!='+ IntToHex( temp , 4 ) );
             chipSame :=FALSE;
           end;
         readFuses: ;
       else
       end;

{
       if hexData.data[ chipAddress ] <> temp then chipSame :=FALSE;
       if (hexData.data[ chipAddress ] AND $FF) <> (temp AND $FF) then dataSame :=FALSE;
 }

       opStr := IntToHex( chipAddress, 4 )+' :';
{
       Row := chipAddress div 8;
       StringGrid1.Cells[ 0,     Row +1 ] := IntToHex( Row * 8 ,4);
}
       for cnt1 := 0 to 7 do
       begin
         case progMode of
           readData:  wrtCmd( RD_DATA_MEM  );
           readProg:  wrtCmd( RD_PRG_MEM  );
           readFuses: wrtCmd( RD_PRG_MEM  );
         else
         end;
         temp  := rdData;
         chipData.data[ chipAddress ] := temp;
         if  chipAddress = $2006 then
           LBchipID.caption := 'Chip ID: '+IntToHex( temp, 4);

         if temp <> $3FFF then BlankChip := FALSE;
         case progMode of
           readData: if (hexData.data[ chipAddress ] AND $FF) <> (temp AND $FF) then dataSame :=FALSE;
           readProg:  if hexData.data[ chipAddress ] <> temp then chipSame :=FALSE;
           readFuses: ;
         else
         end;

 {
         Col := chipAddress mod 8;
         Row := chipAddress div 8;
         StringGrid1.Cells[ Col+1, Row +1 ] := IntToHex(chipData.data[ chipAddress ],4);
 }
         chipAddress := chipAddress +1 ;
         wrtCmd(INC_ADDR);
         opStr := opStr + ' ' + IntToHex( temp, 4 );
       end;

       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;
       cnt2  := cnt2  +8;


       case progMode of
         readData:   if chipAddress > $2100 + dataMemMax   then state := $41;
         readProg:   if chipAddress > progMemMax -1 then state := $41;
         { 16F88 has two configs }
         readFuses:  if chipAddress > fuseMemMax { $2010 }   then state := $41;
       else
       end;
     end;

     $41:
     Begin

       opstr := '-----------';
       if blankChip = TRUE then opstr := opstr +': Blank   Chip ';
       if chipSame  = TRUE then opstr := opstr +': prog Chip == File ';
       if dataSame  = TRUE then opstr := opstr +': data Chip == File ';
       opstr := opStr + ': -----------';

       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;
       Remove5VandVPP;
       state := $1000;
       Label5.caption := 'Finished';
       timerEraseOne;
     end;



     $50:
     Begin
       InitButtonStates;
       if ConnectComPort then
       begin
         { zero bits }
         resetData;
         resetClk;
         Remove5VandVPP;
         BlankChip    := TRUE;
         ChipSame     := TRUE;
         state  := state +1;
         label5.caption := 'Erasing 10F204...';
         Label11.caption := '';

       end
       else
       begin
         Label11.caption := 'Error: COM Port in use...';
         state  := $1000;
       end
     end;

     $52:
     Begin
       resetData;
       resetClk;
       Apply5VandVPP;
       state  := state +1;
     end;

     $54:
     Begin
       wrtCmd( ERASE_PROG );
       state  := state +1;
     end;


     $58:
     Begin
       Remove5VandVPP;
       state := $1000;
       Label5.caption := 'Finished';
     end;


     $60: { Program 10F204 fuses }
     Begin
       InitButtonStates;

       Remove5VandVPP;

       BlankChip    := TRUE;
       ChipSame     := TRUE;

       Form1.Cursor :=  crHourGlass;
       ConnectComPort;
       { zero bits }

       resetData;
       resetClk;
       Remove5VandVPP;
       state  := state +1;
       label5.caption := 'Programming fuses 10F204 ...';

     end;

     $62:
     Begin
       resetData;
       resetClk;
       Apply5VandVPP;
       state  := state +1;
     end;

     $64:
     Begin
       wrtCmd( LD_PRG_MEM );
       // pick up configuration word
       wrtData( hexData.data[ $0FFF ] );
       wrtCmd( PROG_NO_ERASE ); {  For 16F877 use NO_ERASE_PROG }
       state  := state +1;
     end;

     $65:
     Begin
       wrtCmd( PROG_STOP ); {  For 16F877 use NO_ERASE_PROG }
       state  := state +1;
     end;

     $66:
     Begin
       Remove5VandVPP;
       state := $1000;
       Label5.caption := 'Finished';
     end;

     {---------------------------------------------------------------------}
     { I2C Chip }
     $100..$1ff:
     begin
       timer1IIC; { in  ppdelpInclude.pas}
     end;

     {---------------------------------------------------------------------}
     { I2C Display }
     $200..$2ff:
     begin
       timer1CrownHill; { in  ppdelpInclude.pas}
     end;


     {---------------------------------------------------------------------}
     { PIC16F88 Chip }

     $300..$380:
        timer1PIC16F88( 0 );
     {---------------------------------------------------------------------}
     { bulk erase }

     $A00..$A80:
          timer1Erase( 0 );





     { -------------------------------------------------------- }
     { program chip state machine }


     $AFC: { Program the location}
     begin
       case RG_device.ItemIndex of
       2:
       begin { 10F204 }
         wrtCmd(RD_PRG_MEM);
         temp := rdData;
         wrtCmd(  INC_ADDR  );
         state := $B00;
       end
       else
       begin
         state := $B00;
       end;
       end;{case}
     end;



     {---------------------------------------------------------------------}
     { Program Program Memory }

     $B00: { Program Program Memory }
     begin
       Label6.caption := '--- Prog Mem ---' ;
       Label6.color := clLime ;

       Memo1.lines.add( ' ..Programming Program Memory ...');
       Memo1.lines.add( ' ');
       chipAddress := $0000;

       state := state + 1;

       case RG_device.ItemIndex of
       2:
       begin
         wrtCmd( LD_PRG_MEM );
         wrtData( hexData.data[ chipAddress ] );
         wrtCmd( PROG_NO_ERASE ); {  For 16F877 use NO_ERASE_PROG }
         state := $B01;
       end
       else
       begin
       end
       end;{case}
     end;

     $B01: { Program the location}
     begin

       case RG_device.ItemIndex of
       2:
       begin   { prog 10F204 fuses }{ Program the location}
         wrtCmd( PROG_STOP ); {  For 16F877 use NO_ERASE_PROG }
         state := $B02
       end
       else
       begin
         wrtCmd( LD_PRG_MEM );
         wrtData( hexData.data[ chipAddress ] );
         wrtCmd( PROG_NO_ERASE ); {  For 16F877 use NO_ERASE_PROG }
         state := $B02;
       end;
       end;{case}
     end;

     $B02: { Program the rest}
     begin
       Timer1.Interval := 25 ; { ms }

       { after delay test if program worked }
       wrtCmd(RD_PRG_MEM);
       temp := rdData;
       { test if last location programmed? }
       if temp <> hexData.data[ chipAddress ] then
       begin
         Memo1.lines.add( 'Prog ' +intToHex(chipAddress,4)
                         +' Error:'+intToHex(temp,4)+'<>'
                         +intToHex(hexData.data[ chipAddress ],4) );
         Memo1.lines.add( ' ' );
         Errors := TRUE;
       end else
       begin
         { program was successful }
         Label6.caption := 'location: ' +intToHex(chipAddress,4)+' ok:'+
                           intToHex(temp,4)+'=='+
                           intToHex(hexData.data[ chipAddress ],4) ;

         tsNow := now;

         ts := tsNow - ts;

         str( ts*24*3600:10:5 , tsStr );
         Memo1.lines.strings[ Memo1.lines.count-1 ]   := 'Prog '+ Label6.caption  ;
         // MFuses.lines.add(tsStr) ;
         //ts := tsNow;

       end;
       { inc through memory that does not need programming }
       finished := false;
       While not finished do
       Begin
         getTicks := GetTickCount();   { not used - gets ticks since windows started }
         skipped := false ;
         if  ( hexData.data[ chipAddress ] = $3FFF )    then
         begin
           Label6.caption := 'Programming prog skipping '+ intToHex(chipAddress,4);
           Memo1.lines.strings[ Memo1.lines.count - 1 ] := Label6.caption ;
           skipped := true ;
         end;
         { increment address }
         wrtCmd( INC_ADDR );
         chipAddress := chipAddress + 1;
         if    ( hexData.data[ chipAddress ] <> $3FFF )
             //or ( chipAddress > $3FF ) then
             or ( chipAddress > progMemMax ) then
          begin
            finished := true;
          end;
       end;
       { wind state back to program next location }
       state := $B01;
       //if chipAddress > $3FF then
       //if chipAddress > $1FF then
       //if chipAddress > $0FF then
       if chipAddress > progMemMax then
       begin
         state := $C00;
       end
       else
       begin
         if ( skipped ) then
         begin
           { if skipped then delay start of programming next location }
           state := $B01;
         end else
         begin
           wrtCmd( LD_PRG_MEM );
           wrtData( hexData.data[ chipAddress ] );
           wrtCmd( PROG_NO_ERASE ); {  For 16F877 use NO_ERASE_PROG }

           case RG_device.ItemIndex of
           2:
             state := $B01
           else
             state := $B02;
           end;{ case }


         end
       end;

     end;


     $B03: { Finish programming 10F204 }
     begin
       state := $C00;
     end;

     $B04: { Program Data Memory}
     begin
       Label6.caption := '--- Prog Mem ---' ;
       Label6.color := clRed ;

       Memo1.lines.add( ' ..Programming Data Memory...');
       Memo1.lines.add( ' ');
       chipAddress := $2100;
       state := $B05;
     end;

     $B05: { Program Data Memory}
     begin
       wrtCmd( LD_DATA_MEM );
       wrtData( hexData.data[ chipAddress ] );
       state := state + 1;
       wrtCmd( PROG_NO_ERASE );
       state := $B06;
     end;

     $B06: { Program Data Memory }
     begin
       if  ( hexData.data[ chipAddress ] <> $3FFF ) then
       begin
         wrtCmd(RD_DATA_MEM);
         temp := rdData;
         if (temp AND $00FF) <> ( hexData.data[ chipAddress ] AND $00FF ) then
         begin
           Memo1.lines.add( 'Prog ' +intToHex(chipAddress,4)
                         +' Error:'+intToHex(temp,4)+'<>'
                         +intToHex(hexData.data[ chipAddress ],4) );
           Memo1.lines.add( ' ' );
           Errors := TRUE;
         end else
         begin
           Label6.caption := 'Location: ' +intToHex(chipAddress,4)+' ok:'+
               intToHex(temp,4)+'=='+intToHex(hexData.data[ chipAddress ],4) ;

           Memo1.lines.strings[ Memo1.lines.count - 1 ] := 'Programming '+ Label6.caption ;
         end;
       end;

       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;
       { skip locations that are $3FFF, assumes chip erased  }

       while ( ( hexData.data[ chipAddress ] = $3FFF ) and  ( chipAddress < $2100+256 ) ) do
       begin
         Label6.caption := 'Programming data skipping '+ intToHex(chipAddress,4) ;
         Memo1.lines.strings[ Memo1.lines.count - 1 ] := Label6.caption ;
         wrtCmd( INC_ADDR );
         chipAddress := chipAddress + 1;
       end;
       state := $B05;
       if chipAddress > $2100+dataMemMax then
       begin
         if CB_inc_conf.checked then
           state := $B07
         else
           state := $C00;
       end ;
       Timer1.Interval := 50 ; { ms }

     end;

     $B07: { Program Configuration Memory}
     begin
       state := $C00;
       if  CB_inc_conf.checked then
         state := $B08;
     end;


     $B08: { Program Configuration Memory}
     begin
       Label6.color := clYellow ;
       Memo1.lines.add( ' ..Programming Configuration Memory...');
       Memo1.lines.add( ' ');

       case RG_device.ItemIndex of
       2:
       begin
         { prog 10F204 fuses }
         { only available before first INC_ADDRESS }
         state := $60;
       end

       else
       begin
         { prog Other fuses }
         chipAddress := $2000;

         wrtCmd(  LD_CONF );
         wrtData( $3FFF   ); {}
         state := $B09;
       end;
       end;{case}
     end;

     $B09:
     begin
       wrtCmd( LD_PRG_MEM );
       { The Buffer PIC holds back the ppCLKO for 1 ms }
       wrtData( hexData.data[ chipAddress ] );
       state := state + 1;
       wrtCmd( PROG_NO_ERASE );
       state := $B0A;
     end;


     $B0A: { Program fuses }
     begin
       wrtCmd(RD_PRG_MEM);
       temp := rdData;
       if  chipAddress = $2006 then
       begin
         LBchipID.caption := 'Chip ID read as: ' +intToHex(temp,4) ;
       end;

       if ( temp <> hexData.data[ chipAddress ] ) and ( chipAddress <> $2006 ) then
       begin
         Memo1.lines.add( 'Prog ' +intToHex(chipAddress,4)
                         +' Error:'+intToHex(temp,4)+'<>'
                         +intToHex(hexData.data[ chipAddress ],4) );
         Memo1.lines.add( ' ' );
         Errors := TRUE;
       end else
       begin
         Label6.caption := 'location ' +intToHex(chipAddress,4)+
                           ' ok:'      +intToHex(temp,4)+
                           '=='        +intToHex(hexData.data[ chipAddress ],4) ;

         Memo1.lines.strings[ Memo1.lines.count - 1 ] := 'Programming '+ Label6.caption ;
       end;

       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;

       state := $B0A;
       if chipAddress > fuseMemMax then
       begin
         state := $C00;
       end else
       begin
         wrtCmd( LD_PRG_MEM );
         wrtData( hexData.data[ chipAddress ] );
         state := state + 1;
         wrtCmd( PROG_NO_ERASE );
         state := $B0A;
       end;
     end;



     $B14: { Program 16F88 Data Memory}
     begin
       Memo1.lines.add( ' ..Programming 16F88 Data Memory...');
       Memo1.lines.add( ' ' );
       chipAddress := $2100;
       state := $B15;
     end;

     $B15: { Program 16F88  Data Memory}
     begin
       wrtCmd( LD_PRG_MEM );
       wrtData( $0001 );
       wrtCmd( BEGIN_ERASE );
       state := state + 1;
     end;

     $B16: { Program 16F88  Data Memory}
     begin
       wrtCmd( END_PROG );
       state := state + 1;
     end;

     $B17: { Program 16F88  Data Memory}
     begin
       wrtCmd( END_PROG );

       wrtCmd( LD_PRG_MEM );
       wrtData( hexData.data[ chipAddress ] );

       wrtCmd( BEGIN_PROG );
       state := state + 1;
     end;

     $B19: { Program 16F88  Data Memory }
     begin
       wrtCmd( END_PROG );

       if  ( hexData.data[ chipAddress ] <> $3FFF ) then
       begin
         wrtCmd(RD_DATA_MEM);
         temp := rdData;
         if (temp AND $00FF) <> ( hexData.data[ chipAddress ] AND $00FF ) then
         begin
           Memo1.lines.add( 'Prog ' +intToHex(chipAddress,4)
                         +' Error:'+intToHex(temp,4)+'<>'
                         +intToHex(hexData.data[ chipAddress ],4) );
           Memo1.lines.add( ' ' );
           Errors := TRUE;
         end else
         begin
           Label6.caption := 'Location: ' +intToHex(chipAddress,4)+' ok:'+
               intToHex(temp,4)+'=='+intToHex(hexData.data[ chipAddress ],4) ;
           Memo1.lines.strings[ Memo1.lines.count - 1 ] := 'Programming '+ Label6.caption ;
         end;
       end;


       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;
       { skip locations that are $3FFF, assumes chip erased  }

       while ( ( hexData.data[ chipAddress ] = $3FFF ) and  ( chipAddress < $2100+dataMemMax ) ) do
       begin
         Label6.caption := 'Programming data skipping '+ intToHex(chipAddress,4) ;
         Memo1.lines.strings[ Memo1.lines.count - 1 ] := Label6.caption ;
         wrtCmd( INC_ADDR );
         chipAddress := chipAddress + 1;
       end;
       state := $B15;
       if chipAddress > $2100+dataMemMax-1 then
       begin
         state := $C00;
       end
     end;




     {---------------------------------------------------------------------}
     { turn off Programming }

     $C00:
     Begin
       if Errors = TRUE then
         Memo1.Lines.Add('----Errors!!!-------')
       else
         Memo1.Lines.Add('--------------------');
       Remove5VandVPP;

       { finished section }


       { do it again for data }
       // if CB_inc_data.checked then
       // begin
       state := 1;
       case progMode of
         bulkEraseProg,bulkEraseBoth:
           progMode := progProg;

         progProg:
           progMode := progData;

         progData:
           progMode := progFuses;

         else
           state := $1000;
           if Errors = TRUE then
             Memo1.Lines.Add('----Errors!!!-------')
           else
             Memo1.Lines.Add('--- No Errors !  ---');
           Remove5VandVPP;
         end;
     end;



     {---------------------------------------------------------------------}
     { finish }
     $1000:
     Begin

       if progChip then
       begin
         { need to work through list of routines }
       end;


       MFuses.Visible := True;
       MData.Visible  := True;
       MProg.Visible  := True;

       state := 0;
       resetClk;
       resetData;
       Remove5VandVPP;
       Form1.Cursor :=  crDefault;

       Button1.enabled  :=true;
       Button2.enabled  :=true;
       Button3.enabled  :=true;
       Button5.enabled  :=true;

       Button6.enabled  :=true;
       Button7.enabled  :=true;
       Form3.Button8.enabled  :=true;
       Button9.enabled  :=true;
       Button10.enabled :=true;

       Button11.enabled :=true;
       Button12.enabled :=true;
       Form3.Button13.enabled :=true;
       Form3.Button14.enabled :=true;

       Button16.enabled :=true;

       BitBtn1.enabled :=false;
       Memo1.lines.add( ' ..Finished...');

       DisConnectComPort;

       Label6.color := clBtnFace ;
       Label6.caption := '-------' ;

     End;


     { Other States }
     else
       if  state <> 0 then
       begin
         state  := state + 1;
       end;
     end;
end;

{ read Data }
procedure TForm1.Button6Click(Sender: TObject);
begin
  Errors   := FALSE;
  MData.lines.clear;
  progMode := readData;
  progChip := False ;
  state    := 1;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Errors := FALSE;
  MFuses.lines.clear;
  progMode := readFuses;
  progChip := False ;
  state    := 1;

end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin { abort button }
  Errors   := FALSE;
  progMode := readFuses;
  progChip := False ;
  state    := $1000;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
   cnt : integer;
begin
  Form3.show;
  Errors   := FALSE;
  progMode := progProg ;
  progChip := False ;
  state    := $100  ;
end;

{ Program }
procedure TForm1.Button9Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progProg ;
  progChip := False ;
  state    := $1       ;
end;

{ Bulk Erase }
procedure TForm1.Button10Click(Sender: TObject);
begin
  { Bulk erase should do _, bulk erase, _ , _ , _ }
  //if CB_inc_reload.checked then
  //   ReopenLast1Click( sender );

  Errors   := FALSE;
  progMode := bulkEraseProg;
  progChip := True ; { used to move onto next stage }
  state    := $1;

  case RG_device.ItemIndex of
  0: { 1684 like }
  begin { bulk erase - was 16F84  }
  end;

  1: { 12675 like }
  begin
  { bulk erase 12F675 }
    MData.lines.clear;
    progMode := bulkEraseBoth;
  end;

  2: { 10F204 like }
  begin
    { bulk erase 10F204 }
    state    := $45 ;
    LBchipID.caption := 'conf:'+IntToHex( HexData.data[$0FFF],4);
  end;

  3: { 16F88 like}
  begin
    { bulk erase - was 16F84  }
  end;
  end;

end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progData ;
  progChip := False ;
  state    := $1       ;

end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progFuses ;
  progChip := False ;
  state    := $1       ;

    case RG_device.ItemIndex of
  0: { 1684 like }
  begin
  end;

  1: { 12675 like }
  begin
  end;

  2: { 10F204 like }
  begin
    state    := $60  ;
    LBchipID.caption := 'conf:'+IntToHex( HexData.data[$0FFF],4);
  end;

  3: { 16F88 like}
  begin
  end;
  end;


end;

procedure TForm1.ReopenLast1Click(Sender: TObject);
begin
    Memo1.Lines.Clear;
    MProg.Lines.Clear;
    MData.Lines.Clear;
    MFuses.Lines.Clear;

    //FileName := OpenDialog1.FileName
    Filename := ComboBox1.Text;

    if FileExists( FileName ) Then
      Memo1.Lines.LoadfromFile(FileName);
    processMemo;
end;


procedure TForm1.processMemo;
var
   cnt, cnt2 : integer;
   lineStr   : string;
   code      : integer;
   OscCalVal : integer;
begin
    ReopenLast1.Enabled := True;
    Button2.Enabled     := True;
    HexData.maxProgAddress      := $0;
    for cnt := 0  to maxPicData -1 do
    begin
      HexData.data[cnt] := $3FFF ; { Unprogrammed state }
    end;

    { process the HEX file read into the memo }

    for cnt := 0  to Form1.Memo1.Lines.count do
    begin
         ProcessLine(     HexData, Form1.Memo1.Lines[cnt] );
    end;

    if OscCal.checked  then  begin
      val('$' + Edit5.Text,OscCalVal,code);
      HexData.data[ $3FF ] := OscCalVal and $3FFF ;
    end;


    Form1.Mfuses.Lines.add( '' );
    Form1.Mfuses.Lines[ 0 ] := IntToHex( $2000 , 4    )+' : ' ;
    for cnt := $2000+0 to $2000+7 do
    begin
      Form1.Mfuses.Lines[0] := Form1.Mfuses.Lines[0]+
                               IntToHex(HexData.data[cnt],4)+' ';
    end;

    {Form1.Mfuses.Lines.add( '' ); }
    Form1.Mfuses.Lines[ 1 ] := '10F204: '+IntToHex( $0FFF , 4    )+' : ' ;

{    Form1.Mfuses.Lines.add( '' );   }
    Form1.Mfuses.Lines[ 2 ] :=  'MaxProgAddress:' + IntToHex( hexData.maxProgAddress, 4 );


    Form1.MData.Visible := False;
    for cnt2:= 0 to ( 64 div 8 ) do
    begin
      Form1.MData.Lines.add( '' );
      lineStr := '';
      for cnt := $2100+cnt2*8  to $2100+cnt2*8+7 do
      begin
        lineStr := lineStr + IntToHex( HexData.data[cnt], 4 )+' ';
      end;
      Form1.MData.Lines[cnt2] := IntToHex( $2100 + (cnt2*8), 4 )+' : ' + lineStr ;
    end;
    Form1.MData.Visible := True;

    Form1.MProg.Visible := False;

    for cnt2:= 0 to ( ($2000-1) div 8 ) do
    begin
      Form1.MProg.Lines.add( '' );
      lineStr := '';
      for cnt := $0000+cnt2*8  to $0000+cnt2*8+7 do
      begin
        lineStr := lineStr+IntToHex( HexData.data[cnt], 4 )+' ';
      end;
      Form1.MProg.Lines[ cnt2 ] := IntToHex( $0000 + cnt2 * 8, 4 )+' : ' + lineStr ;
    end;

    Form1.MProg.Visible := True;

    { here }


end;

procedure TForm1.FormActivate(Sender: TObject);
begin
{     IniFile  := TIniFile.Create('ppdelp.Ini'); }
     IniFile  := TRegIniFile.Create('ppdelp.Ini');

     RG_device.ItemIndex  := IniFile.ReadInteger('device','LastDevice',1);

     FileName := IniFile.ReadString('files','lastFile','');

     FileName := IniFile.ReadString('files','lastFile','');
     FileNameA[0] := IniFile.ReadString('files','lastFile0','');
     FileNameA[1] := IniFile.ReadString('files','lastFile1','');
     FileNameA[2] := IniFile.ReadString('files','lastFile2','');
     FileNameA[3] := IniFile.ReadString('files','lastFile3','');
     FileNameA[4] := IniFile.ReadString('files','lastFile4','');
     FileName := IniFile.ReadString('files','lastFile','');

     ComboBox1.Items.Insert( 0 , FileNameA[4] );
     ComboBox1.Items.Insert( 0 , FileNameA[3] );
     ComboBox1.Items.Insert( 0 , FileNameA[2] );
     ComboBox1.Items.Insert( 0 , FileNameA[1] );
     ComboBox1.Items.Insert( 0 , FileNameA[0] );




    Edit3progMemMax.text := IniFile.ReadString( 'progMemMax','LastProgMemMax','1024');
    Edit4dataMemMax.text := IniFile.ReadString( 'dataMemMax','LastDataMemMax','128');
    Edit5fuseMemMax.text := IniFile.ReadString( 'fuseMemMax','LastFuseMemMax','$200F');


     Caption  := FileName;
     ComboBox1.Text := FileName;

     if ( Filename <> '' ) then
     begin
       Memo1.Lines.Clear;
       if FileExists( FileName ) then
       begin
         Memo1.Lines.LoadfromFile(FileName);
         Label6.caption := '';
       end
       else
       begin
         Label6.caption := 'file does not exist!!';
       end;
       processMemo;

     end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IniFile.WriteInteger('device','LastDevice',RG_device.ItemIndex );
  IniFile.WriteString('files','lastFile',FileName);

  IniFile.WriteString('progMemMax','LastProgMemMax',Edit3progMemMax.text );
  IniFile.WriteString('dataMemMax','LastDataMemMax',Edit4dataMemMax.text );
  IniFile.WriteString('fuseMemMax','LastFuseMemMax',Edit5fuseMemMax.text );

  IniFile.Free;

end;

{ Prog Chip }
procedure TForm1.Button1Click(Sender: TObject);

begin
 { Prog Chip should do load file, bulk erase, prog Prog, Prog Data, Prog Fuses }
 progChip := True ; { used to move onto next stage }


// if CB_inc_reload.checked then
   ReopenLast1Click( sender );

// if CB_inc_erase.checked then
//    Button10Click( sender );



 case RG_device.ItemIndex of
   3: { 16F88 }
   begin
     Errors   := FALSE;
     MData.lines.clear;
     progMode := bulkEraseBoth;
     state    := $300;
   end
   else
   begin
     Errors   := FALSE;
     progMode := bulkEraseProg; ;
     state    := $1       ;
   end;
 end; {  case RG_device.ItemIndex of }
end;

{ Reload File }
procedure TForm1.Button2Click(Sender: TObject);
begin
  progChip := False ;
  ReopenLast1Click( sender );
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Form1.Close
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

procedure TForm1.file11Click(Sender: TObject);
begin
     Filename := Caption;
     ComboBox1.text :=  Filename ;
end;


procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  Filename := ComboBox1.Text;
  if ( Filename <> '' ) then
  begin
    Memo1.Lines.Clear;
    if FileExists( FileName ) then
    begin
      Memo1.Lines.LoadfromFile(FileName);
    end;
    processMemo;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Errors   := FALSE;
  MData.lines.clear;
  progMode := bulkEraseData;
  progChip := False ;
  state    := 1;
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  Errors   := FALSE;
  MData.lines.clear;
  progMode := bulkEraseBoth;
  progChip := False ;
  state    := $180;

end;

procedure TForm1.Button14Click(Sender: TObject);


begin
  Errors   := FALSE;
  progMode := progProg ;
  progChip := False ;  
  state    := $200  ;

end;


procedure TForm1.Button16Click(Sender: TObject);
begin
  progChip := False ;
  Errors   := FALSE;
  state    := $60  ;
  LBchipID.caption := 'conf:'+IntToHex( HexData.data[$0FFF],4);
  RG_device.ItemIndex := 2;
end;

procedure TForm1.Button18Click(Sender: TObject);
begin
  Errors   := FALSE;
  MData.lines.clear;
  progMode := bulkEraseBoth;
  progChip := False ;
  state    := $300;
end;



procedure TForm1.Button19Click(Sender: TObject);
begin
  Errors   := FALSE;
  MData.lines.clear;
  progMode := bulkEraseBoth;
  progChip := False ;
  state    := $1A0;

  label6.caption := 'doug'
end;

   end.
