{ include file }


procedure TForm1.timer1Template( state_offset:integer );
begin
  case state - state_offset of
     { states }
     $20A: { IIC function}
     begin
       state := state + 1;
     end;
  else
    state := state + 1;
  end;
end;

{------------------------------------------------------------------------}

procedure TForm1.timer1PIC16F88( state_offset:integer );
var
  finished :boolean;
  skipped  :boolean;
  skippedCnt :integer;
  bit      :boolean;
  temp     :integer;
  cnt      :integer;
  cnt2     :integer;
  nackSeen :boolean;
  memSize  :integer;
  getTicks :dword;

  byteStr : string;

  Col,Row :integer;

begin
  case state - state_offset of
     {---------------------------------------------------------------------}
     { PIC16F88 Chip }


     $300:
     { Put the chip into programme mode }
     Begin
       InitButtonStates;
       ConnectComPort;
       { zero bits }
       resetData;
       resetClk;
       Remove5VandVPP;
       { Call subroutine at $360 }
       savedState := $301;
       state := $360;
       Label6.color := clLime ;
     end;


     $301:
     Begin
       resetData;
       resetClk;
       Apply5VandVPP;
       state  := state +1;
       cnt1:=0;
       cnt2:=0;

       case progMode of
           readData:       MData.lines.add('.............');
           readProg:       Memo1.lines.add('.............');
           readFuses:      MFuses.lines.add('.............');
           bulkEraseData:  MData.lines.add('..erase......');
       else
       end;
       opStr  := '';

       state := $32E;   { Erase All }
       state := $311;   { Program 16F88  PROG Memory without erase }
       state := $329;   { read  fuses }
       state := $318;   { Program 16F88  Data Memory}
       state := $338;   { wrt fuses }
       state := $330;
       if CB_inc_conf.checked then state := $338;
       if CB_inc_data.checked then state := $318;
       if CB_inc_prog.checked then state := $30C;
     end;


  {----- PIC16F88 Chip Erase -------------------------------------------------}

     $30B:
     begin
       wrtCmd( LD_PRG_MEM );    { $2000 }
       wrtData( $0001 );
       state := state + 1;
       Memo1.lines.add('... 16F688 Chip Erase ...');
     end;


  {----- Program 16F88 PROG Memory -------------------------------------------}
     $30C: { Program 16F88  PROG Memory}
     begin
       state := $311;
       opStr := '';
       chipAddress := $0000;
       Memo1.lines.add('... 16F688 prog memory ...');

     end;


     $30D: { Program 16F88  PROG Memory}
     begin
       wrtCmd( BEGIN_ERASE );   { erase 32 locations }
       state := state + 1;
     end;

     $30F: { Program 16F88  PROG Memory}
     begin
       wrtCmd( END_PROG );
       state := state + 1;
     end;

     $311: { Program 16F88  PROG Memory }
     begin { You need to program four locations at a time }
       { skip any locations to be programmed $3FFF }
       { If All 4 locations are skipped, then do not program }
       skippedCnt := 0;


       if hexData.data[ chipAddress ] = $3FFF then
       begin
         skippedCnt := skippedCnt+1;
       end
       else
       begin
          wrtCmd( LD_PRG_MEM );
          wrtData( hexData.data[ chipAddress ] );
       end;

       chipAddress := chipAddress + 1;
       wrtCmd( INC_ADDR );

       if hexData.data[ chipAddress ] = $3FFF then
       begin
         skippedCnt := skippedCnt+1;
       end
       else
       begin
          wrtCmd( LD_PRG_MEM );
          wrtData( hexData.data[ chipAddress ] );
       end;

       chipAddress := chipAddress + 1;
       wrtCmd( INC_ADDR );

       if hexData.data[ chipAddress ] = $3FFF then
       begin
         skippedCnt := skippedCnt+1;
       end
       else
       begin
          wrtCmd( LD_PRG_MEM );
          wrtData( hexData.data[ chipAddress ] );
       end;

       chipAddress := chipAddress + 1;
       wrtCmd( INC_ADDR );


       if hexData.data[ chipAddress ] = $3FFF then
       begin
         skippedCnt := skippedCnt+1;
       end
       else
       begin
          wrtCmd( LD_PRG_MEM );
          wrtData( hexData.data[ chipAddress ] );
       end;


       if skippedCnt <> 4 then
       begin
         wrtCmd( BEGIN_PROG );
         state := state + 1;
       end
       else
       begin
         if  chipAddress < HexData.maxProgAddress { $3FF } then
         begin
          chipAddress := chipAddress + 1;
           wrtCmd( INC_ADDR );
           state := $311;
           Label6.caption := ( ' ..skip..' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( hexData.data[ chipAddress ], 4 ));
         end
         else
         begin
           state := $314;
         end
       end
     end;

     $313: { Program 16F88  PROG Memory }
     begin
       wrtCmd( END_PROG );
       state := state + 1;

{       Memo1.lines.add( ' ....' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( hexData.data[ chipAddress ], 4 )); }
       Label6.caption := ( ' ....' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( hexData.data[ chipAddress ], 4 ));

       if chipAddress < HexData.maxProgAddress { $3FF } then
       begin
         chipAddress := chipAddress + 1;
         wrtCmd( INC_ADDR );
         state := $311;
       end;
     end;

     $314:
     begin
       state := $330;
       if CB_inc_conf.checked then state := $338;
       if CB_inc_data.checked then state := $318;
     {  if CB_inc_prog.checked then state := $311; }


     end;

  {----- Program 16F88 Data Memory -------------------------------------------}

     $318:   { Program 16F88  Data Memory}
     begin
       { REALLY WE NEED TO BOUNCE THE Vdd and Vpp to reset the pointer. }
       { Call subroutine at $360 }
       savedState := $319;
       state := $360;

       opStr := '';
       chipAddress := $2100;
       Memo1.lines.add('... 16F688 data memory ...');

       { state := $321; } { don't do erase }
     end;

     $31B:
     begin
       wrtCmd( LD_DATA_MEM );    { $2000 }
       wrtData( $0001 );
       state := state + 1;
     end;

     $31D: { Program 16F88  Data Memory}
     begin
       wrtCmd( BEGIN_ERASE );   { erase 1 locations }
       state := state + 1;
     end;

     $31F: { Program 16F88  Data Memory}
     begin
       wrtCmd( END_PROG );
       state := state + 1;
       state := $321;
     end;

     $321: { }
     begin { You need to program one locations at a time }
       while (chipAddress < $2200) and (hexData.data[ chipAddress ] = $3FFF) do
       begin
         { Erased chip is at $3FFF so no need to program }
         wrtCmd( INC_ADDR );
         chipAddress := chipAddress +1 ;
       end;

       if (chipAddress < $2200) then
       begin
         if  hexData.data[ chipAddress ] <> $3FFF then
         begin
           wrtCmd( LD_DATA_MEM );
           wrtData( hexData.data[ chipAddress ] );
           chipAddress := chipAddress + 1;
           wrtCmd( BEGIN_PROG );
           state := state + 1;
           state := $325;
         end
       end
       else
       begin { end of data }
         state := $326;
       end;
     end;

     $325: { }
     begin
       wrtCmd( END_PROG );
       state := state + 1;
       Memo2.lines.add( ' ....' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( hexData.data[ chipAddress ], 4 ));

       if chipAddress < $2200 then
       begin
         wrtCmd( INC_ADDR );
         state := $31B;
         { state := $321; }{ don't do erase }
       end
       else
       begin
         state := $326;
       end;
     end;

     $326: { Next }
     begin
       state := $330;
       if CB_inc_conf.checked then state := $338;
{       if CB_inc_data.checked then state := $318; }
{       if CB_inc_prog.checked then state := $311; }
     end;


  {----- Program 16F88 Read Conf Memory -------------------------------------}

     $329:
     begin
       wrtCmd( LD_CONF );    { $2000 }
       wrtData( $0001 );
       wrtCmd( LD_PRG_MEM );
       wrtData( $0001 );
       state := state + 1;
       Memo1.lines.add('... 16F688 read conf ...');
     end;

     $32D:
     begin
       wrtCmd( RD_PRG_MEM  );
       temp := rdData;
       opStr := opStr + ' ' + IntToHex( temp, 4 );

       chipData.data[ chipAddress ] := temp;
       chipAddress := chipAddress +1 ;

       wrtCmd( INC_ADDR );
       cnt1 := cnt1+1;

       if cnt1 = 10 then
       begin
         Memo2.lines.add( ' ....' + opStr );
         state := $330;
       end;
     end;


     $32E:
     begin
       wrtCmd( CHIP_ERASE );    { $2000 }
       state := state + 1;
     end;

     $330:
     Begin
       MFuses.Visible := True;
       MData.Visible  := True;
       MProg.Visible  := True;

       state := 0;
       resetClk;
       resetData;
       Remove5VandVPP;
       Form1.Cursor :=  crDefault;

       Button1.enabled  :=true;
       Button2.enabled  :=true;
       Button3.enabled  :=true;
       Button5.enabled  :=true;

       Button6.enabled  :=true;
       Button7.enabled  :=true;
       Button9.enabled  :=true;
       Button10.enabled :=true;

       Button11.enabled :=true;
       Button12.enabled :=true;


       Button16.enabled :=true;


       BitBtn1.enabled :=false;
       Memo1.lines.add( ' ..Finished...');
       DisConnectComPort;
     end;


  {----- PIC16F88 Fuses -------------------------------------------------}
     $338: { Program 16F88 Fuses Memory}
     begin { You need to program four locations at a time }
       { Call subroutine at $360 }
       savedState := $339;
       state := $360;
       Memo1.lines.add('... 16F688 fuses memory ...');
     end;


     $339: { Program 16F88 Fuses Memory}
     begin { You need to program four locations at a time }
       chipAddress := $2000;
       wrtCmd( LD_CONF );    { $2000 }
       wrtData( $3FFF );
       wrtCmd( LD_PRG_MEM );
       wrtData( $0001 );
       state := state + 1;
     end;


     $33A: { Program 16F88  ID Memory}
     begin
       wrtCmd( LD_PRG_MEM );
       wrtData( $0001 );
       wrtCmd( BEGIN_ERASE );   { erase 32 locations }
       state := state + 1;
     end;

     $33C: { Program 16F88  ID Memory}
     begin
       wrtCmd( END_PROG );
       state := state + 1;
     end;

     $33E: { Program 16F88  ID Memory}
     begin { You need to program the four ID locations at a time }

       Memo1.lines.add( ' ....' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( hexData.data[ chipAddress ], 4 ));

       wrtCmd( LD_PRG_MEM );
       wrtData( hexData.data[ chipAddress ] );
       chipAddress := chipAddress + 1;
       wrtCmd( INC_ADDR );

       wrtCmd( LD_PRG_MEM );
       wrtData( hexData.data[ chipAddress ] );
       chipAddress := chipAddress + 1;
       wrtCmd( INC_ADDR );

       wrtCmd( LD_PRG_MEM );
       wrtData( hexData.data[ chipAddress ] );
       chipAddress := chipAddress + 1;
       wrtCmd( INC_ADDR );

       wrtCmd( LD_PRG_MEM );
       wrtData( hexData.data[ chipAddress ] );

       wrtCmd( BEGIN_PROG );
       state := state + 1;
     end;

     $341: { Program 16F88  ID Memory }
     begin
       wrtCmd( END_PROG );
       state := state + 1;
       Memo1.lines.add( ' ....' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( hexData.data[ chipAddress ], 4 ));
       { now pointing at $2003 }
       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;

       { now pointing at $2004 }
       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;

       { now pointing at $2005 }
       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;

       { now pointing at $2006 - CHIP ID }
       wrtCmd(RD_PRG_MEM);
       temp := rdData;
       Memo1.lines.add( ' ..ID..' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( temp, 4 ));

       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;
       { now pointing at $2007 }
       { Write Conf1 }
       Memo1.lines.add( ' ..C1..' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( hexData.data[ chipAddress ], 4 ));

       wrtCmd( LD_PRG_MEM );
       wrtData( hexData.data[ chipAddress ] );

       wrtCmd( BEGIN_PROG );
       state := state + 1;
     end;

     $344: { Program 16F88  PROG Memory }
     begin
       wrtCmd( END_PROG );
       wrtCmd(RD_PRG_MEM);
       temp := rdData;
       Memo1.lines.add( ' ..C1 r.' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( temp, 4 ));
       state := state + 1;
       { state := $330; }
     end;

     $347: { Program 16F88  PROG Memory }
     begin

       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;
       { now pointing at $2008 }
       { Write Conf1 }
       Memo1.lines.add( ' ..C2..' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( hexData.data[ chipAddress ], 4 ));

       wrtCmd( LD_PRG_MEM );
       wrtData( hexData.data[ chipAddress ] );

       wrtCmd( BEGIN_PROG );
       state := state + 1;
     end;

     $349: { Program 16F88  PROG Memory }
     begin
       wrtCmd( END_PROG );

       wrtCmd(RD_PRG_MEM);
       temp := rdData;
       Memo1.lines.add( ' ..C1 rD..' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( temp, 4 ));

       state := $330;
     end;

     $34B: { Program 16F88  PROG Memory }
     begin
       wrtCmd( END_PROG );
       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;
       { now pointing at $2008 }
       { Write Conf1 }
       wrtCmd( LD_PRG_MEM );
       wrtData( hexData.data[ chipAddress ] );

       Memo1.lines.add( ' ....' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( hexData.data[ chipAddress ], 4 ));
       Label6.caption := ( ' ....' + IntToHex( chipAddress, 4 ) + ' = ' + IntToHex( hexData.data[ chipAddress ], 4 ));
       wrtCmd( BEGIN_PROG );
       state := state + 1;
     end;


  {----- END of PIC16F88 Fuses -------------------------------------------------}

  {----- Fuses -------------------------------------------------}

     $360 +3:
     Begin
       Timer1.Interval := 50; {ms}
       resetData;
       resetClk;
       Apply5V;
       state  := state +1;
       Label5.caption := 'Programming...';
       Memo1.lines.add('... Bouncing Vpp ...');
     end;

     $360 +10:
     {
     With 5volts on Chip, bounce MCLR/VPP pin,
     Programming mode is entered if
     data and Clk = 0 when Vpp raised to 12 volts.
     Most 16F84 seems to programme well outside
     the spec.
     }
     Begin
       resetData;
       resetClk;
       Remove5VandVPP;
       state  := state +1;
     end;

     $360 +11:
     {
     With 5volts on Chip, bounce MCLR/VPP pin,
     Programming mode is entered if
     data and Clk = 0 when Vpp raised to 12 volts.
     Most 16F84 seems to programme well outside
     the spec.
     }
     Begin
       resetData;
       resetClk;
       Remove5VandVPP;
       state  := state +1;
     end;


     { progress with a bit of delay }
     $360 +12:
     Begin
       resetData;
       resetClk;
       Apply5V;
       state  := state +1;
     end;

{
     13..19:
     Begin
       resetData;
       resetClk;
       Apply5V;
       state  := state +1;
     end;
}

     $360+19:
     Begin
       state  := state +1;
       { return to saved state if there is one }
       if savedState > 0 then
       begin
         state := savedState ;
         savedState := 0;
       end;
       Timer1.Interval := 5; {ms}
     end;
  else
    state := state + 1;
  end;
end;




{------------------------------------------------------------------------}
procedure TForm1.timer1IIC;
var
  finished :boolean;
  skipped  :boolean;
  skippedCnt :integer;
  bit      :boolean;
  temp     :integer;
  cnt      :integer;
  cnt2     :integer;
  nackSeen :boolean;
  memSize  :integer;
  getTicks :dword;

  valError :integer;

  byteStr : string;

  Col,Row :integer;

begin
  case state of
     {
     24L16 summary

         CMD.W ADDR   note: the cmd contains 3 bits of ADDR

         CMD.W ADDR DATA .. DATA    up to 8 words

         CMD.R getDATA getDATA

     24L65 summary   ( not includeing write protect features )

         CMD.W ADDR ADDR

         CMD.W ADDR ADDR DATA .. DATA    up to 64 words

         CMD.R getDATA getDATA


     }
     $100: { IIC function}
     begin
       InitButtonStates;

       ConnectComPort;
       Memo1.lines.add( ' .. IIC mode...');
       chipAddress := $0000;
       ApplyIICpower;
       cnt3 := 0;
       state := state + 1;
     end;

     $108: { IIC function}
     begin
       ApplyIICStart;
       state := state + 1;
       if Form3.ComboBox2.ItemIndex = 0 then
         state := $110;
     end;

     $109: { IIC function}
     begin
       { Reading 24LC65 device }
       Memo1.lines.add( ' Reading 24LC65 device ');

       { CMD.W ADDR ADDR }
       { send control 0xA0  write }
       if writeIICbyte( $A0 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

       { start Address High Byte}
       if writeIICbyte( $00 ) then
         Memo1.lines.add( ' adr ..NACK..')
       else
         Memo1.lines.add( ' adr ..ACK..');

       { start Address low Byte}
       if writeIICbyte( $00 ) then
         Memo1.lines.add( ' adr ..NACK..')
       else
         Memo1.lines.add( ' adr ..ACK..');

       ApplyIICStop;
       state := state + 1;
     end;

     $10A: { IIC function}
     begin
       ApplyIICStart;
       { CMD.R getDATA getDATA }
       if writeIICbyte( $A1 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');
       state := state + 1;
     end;

     $10B: { IIC function}
     begin
       { read }
       byteStr := '';
       for cnt := 0 to 15 do
       begin
         temp := readIICbyte;
         { ACK byte read }
         ApplyIIC_zero;
         byteStr := byteStr + ' '+intToHex( temp,2 );
       end;

       Memo1.lines.add( intToHex( cnt3, 2 )+ '0 : ' +
                        byteStr );

       cnt3  := cnt3 + 1;
       if  ( Form3.ComboBox3.ItemIndex < 0 ) then
         Form3.ComboBox3.ItemIndex := 0;

       memSize := ( 1 shl Form3.ComboBox3.ItemIndex ) * 1024;
       if  cnt3 >= ( memSize / 16 ) then
       begin
         state := state + 1;
       end;
     end;

     $10C: { IIC function}
     begin
       state := state + 1;
     end;

     $10D: { IIC function}
     begin
       ApplyIICStop;
       state := $1000
     end;


     $110: { IIC function}
     begin

       { Read 24L16B device }
       Memo1.lines.add( ' Reading 24L16B device ');

       { CMD.W ADDR ADDR }
       { send control 0xA0  write }
       if writeIICbyte( $A0 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

       { start Address low Byte}
       if writeIICbyte( $00 ) then
         Memo1.lines.add( ' adr ..NACK..')
       else
         Memo1.lines.add( ' adr ..ACK..');

       ApplyIICStop;
       state := state + 1;
     end;

     $111: { IIC function}
     begin
       ApplyIICStart;
       { CMD.R getDATA getDATA }
       if writeIICbyte( $A1 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');
       state := state + 1;
     end;

     $112: { IIC function}
     begin
       { read }
       byteStr := '';
       for cnt := 0 to 15 do
       begin
         temp := readIICbyte;
         { ACK byte read }
         ApplyIIC_zero;
         byteStr := byteStr + ' '+intToHex( temp,2 );
       end;

       Memo1.lines.add( intToHex( cnt3, 2 )+ '0 : ' + byteStr );
       cnt3  := cnt3 + 1;
       if  ( Form3.ComboBox3.ItemIndex < 0 ) then
         Form3.ComboBox3.ItemIndex := 0;
       memSize := ( 1 shl Form3.ComboBox3.ItemIndex ) * 1024;

       if  cnt3 >= ( memSize / 16 ) then
       begin
         state := state + 1;
       end;
     end;


     $114: { IIC function}
     begin
       ApplyIICStop;
       state := $1000
     end;





     $180: { IIC function}
     begin
       InitButtonStates;

       ConnectComPort;
       Memo1.lines.add( ' .. IIC mode...');
       chipAddress := $0000;
       ApplyIICpower;
       cnt3 := 0;
       state := state + 1;
       chipAddress := 0;
       nackSeen := false
     end;

     $188: { IIC function}
     begin
       state := state + 1;
       if Form3.ComboBox2.ItemIndex = 0 then
         state := $190;

     end;

     $189: { IIC function}
     begin
       ApplyIICStart;
       { send control 0xA0  write }
       nackSeen := nackSeen or  writeIICbyte( $A0 );
       { start Address high byte}
       nackSeen := nackSeen or  writeIICbyte( hiByte(chipAddress) );
       { start Address low byte }
       nackSeen := nackSeen or  writeIICbyte( LoByte(chipAddress) );

       state := state + 1;

     end;

     $18A: { IIC function}
     begin
       { now program memory }
       for cnt := 0 to 63 do
       begin
         { data Byte }
         nackSeen := nackSeen or writeIICbyte( hexData.data[ chipAddress + cnt ] );
       end;
       ApplyIICStop;
       { now allow chip to program }
       if nackSeen then
         Memo1.lines.add( '0x'+intToHex(chipAddress + cnt, 4 )+ ' adr ..NACK..')
       else
         Memo1.lines.add( '0x'+intToHex(chipAddress + cnt, 4 )+' adr ..ACK..');

       chipAddress := chipAddress + 63;

       if  ( Form3.ComboBox3.ItemIndex < 0 ) then
         Form3.ComboBox3.ItemIndex := 0;

       memSize := ( 1 shl Form3.ComboBox3.ItemIndex ) * 1024;

       if  chipAddress >= memSize then
         state := $1000
       else
         state := $189;
     end;


     $18B: { IIC function}
     begin
       ApplyIICStop;
       state := state + 1;
     end;


     $18C: { IIC function}
     begin

{       ApplyIIC_one; }
       state := state + 1;
     end;

     $18D: { IIC function}
     begin
       ApplyIICStop;
       state := $1000
     end;

     $190: { IIC function}
     begin
       ApplyIICStart;
       { send control 0xA0 +hi( chipAddress ) write }
       nackSeen := nackSeen or  writeIICbyte( $A0 + hiByte(chipAddress)*2 );
       { start Address low byte }
       nackSeen := nackSeen or  writeIICbyte( LoByte(chipAddress) );
       state := state + 1;

     end;

     $191: { IIC function}
     begin
       { now program memory }
       for cnt := 0 to 15 do
       begin
         { data Byte }
         nackSeen := nackSeen or writeIICbyte( hexData.data[ chipAddress + cnt ] );
       end;
       ApplyIICStop;

       { now allow chip to program }
       if nackSeen then
         Memo1.lines.add( '0x'+intToHex(chipAddress + cnt, 4 )+ ' adr ..NACK..')
       else
         Memo1.lines.add( '0x'+intToHex(chipAddress + cnt, 4 )+' adr ..ACK..');

       chipAddress := chipAddress + 16;

       if  ( Form3.ComboBox3.ItemIndex < 0 ) then
         Form3.ComboBox3.ItemIndex := 0;

       memSize := ( 1 shl Form3.ComboBox3.ItemIndex ) * 1024;

       // Memo1.lines.add( '+++ 0x'+intToHex(chipAddress + cnt, 4 )+'  ');

       if  chipAddress <  memSize then
         state := $190
       else
         state := $1000;
     end;

     $192: { IIC function}
     begin
       ApplyIICStop;
       state := state + 1;
     end;

     $193: { IIC function}
     begin
       state := state + 1;
     end;

     $194: { IIC function}
     begin
       ApplyIICStop;
       state := $1000
     end;


     $1A0: { IIC function}
     begin
       InitButtonStates;

       ConnectComPort;
       Memo1.lines.add( ' ... IIC ...');
       chipAddress := $0000;
       ApplyIICpower;
       cnt3 := 0;
       state := state + 1;
       chipAddress := 0;
       nackSeen := false;
       val( Form3.Edit4.text, IICaddr,valError );
       label6.caption := IntToHex(  IICaddr , 4 )

     end;

     $1A9: { IIC function}
     begin

       { Apply start and send address, if odd address read 8 bytes else write bytes }
       ApplyIICStart;
       { send control 0xA0  write }
       nackSeen := nackSeen or  writeIICbyte( IICaddr );
       { if IICaddr is even then write else read }

       if (IICaddr and 1 ) = 1 then
       begin
         { read }
         state := $1AA;
       end
       else
       begin
         { write }
         Form3.IICdataEdit.Text := '';
         for cnt := 0 to 8 do
         begin
           { data Byte }
           val( Form3.IICdataWrite.text, IICdata,valError );
           IICstring := copy( Form3.IICdataWrite.text,1,valError);
           Form3.IICdataEdit.Text := Form3.IICdataEdit.text +IICstring;
           label6.caption := label6.caption+' '+IntToHex(  IICdata , 2 );
           val( IICstring, IICdata,valError );
           IICstring := Form3.IICdataWrite.text;
           delete( IICstring,1,valError );
           Form3.IICdataWrite.text :=IICstring;
          { label6.caption := label6.caption+' '+IntToHex(  IICdata , 4 ) }
          nackSeen := nackSeen or writeIICbyte( IICdata );
         end;
         { copy back bytes sent }
         Form3.IICdataWrite.text := Form3.IICdataEdit.Text    ;
         ApplyIICStop;
         state := $1000;
       end;
     end;

     $1AA: { IIC function}
     begin
       { read }
       Form3.IICdataEdit.Text := '';
       { data Byte }
       IICdata  := readIICbyte;
       { ACK byte read }
       ApplyIIC_zero;
       Form3.IICdataEdit.Text := Form3.IICdataEdit.text + IntToHex(  IICdata , 2 )+',';
       IICcounter := 0;
       state := state + 1;
     end;


     $1AB: { IIC function}
     begin
       { read }       { data Byte }
       IICdata  := readIICbyte;
       { ACK byte read }
       if ( IICcounter > 5 ) then
       begin
         ApplyIIC_one;
         state := state + 1;
       end
       else
       begin
         ApplyIIC_zero;
       end;

       Form3.IICdataEdit.Text := Form3.IICdataEdit.text + IntToHex(  IICdata , 2 )+',';
       IICcounter := IICcounter + 1;
     end;

     $1AC: { IIC function}
     begin
       ApplyIICStop;
       state := $1000;
     end;
  else
    state := state + 1;
  end;
end;

procedure TForm1.timer1CrownHill;
begin
  { I2C Display }

  { The display is a 20 x 4 display with a pic chip front end
12345678901234567890|
--------------------+
Freq: 0000 0000     |
 time: XX:XX:00     |
start: XX:XX  XX:XX |
 end : XX:XX  XX:XX |
--------------------+
--------------------+
                    |
                    |
                    |
                    |
--------------------+
     }

  case state of
     $200: { IIC function for Crownhill i2c display }
     begin
       InitButtonStates;

       ConnectComPort;
       Memo1.lines.add( ' .. IIC mode...');
       chipAddress := $0000;
       ApplyIICpower;
       cnt3 := 0;
       state := state + 1;

     end;

     $204: { IIC function}
     begin
       ApplyIICStart;
       state := state + 1;

     end;

     $205: { IIC function}
     begin
       { CMD.W ADDR ADDR }
       { send control 0xA0  write }
       if writeIICbyte( $C6 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

       if writeIICbyte( 12 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

       state := state + 1;
       cnt3  := $1;

       if writeIICbyte( 12 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

     end;

     $206: { IIC function}
     begin
       { CMD.W ADDR ADDR }
       { send control 0xA0  write }


       if cnt3 > length(Form3.Edit3.text) then
       begin
         state := state + 1;
         cnt3 := $20;
       end
       else
       begin
         if writeIICbyte( ord( Form3.Edit3.text[cnt3] )  ) then
           Memo1.lines.add( ' cmd ..NACK..')
         else
           Memo1.lines.add( ' cmd ..ACK..');
           cnt3  := cnt3 + 1;
       end;
     end;

     $20A: { IIC function}
     begin
        if writeIICbyte( 4 ) then
           Memo1.lines.add( ' cmd ..NACK..')
         else
           Memo1.lines.add( ' cmd ..ACK..');

       state := state + 1;
       cnt3  := $20
     end;



     $20B: { IIC function}
     begin
       { CMD.W ADDR ADDR }
       { send control 0xA0  write }


       { start Address High Byte}
       if writeIICbyte( cnt3 ) then
         Memo1.lines.add( ' adr ..NACK..')
       else
         Memo1.lines.add( ' adr ..ACK..');

       if  cnt3 = $40  then
       begin
         if writeIICbyte( 17 ) then
           Memo1.lines.add( ' cmd ..NACK..')
         else
           Memo1.lines.add( ' cmd ..ACK..');
       end;


       cnt3  := cnt3  + 1;

       if  cnt3 >= $FF  then
       begin
         ApplyIICStop;
         state := state + 1;
       end

     end;


     $20C: { IIC function}
     begin
       state  := $1000;
     end;

  else
    state := state + 1;
  end;
end;
